;*********************************************************************************************************
;**********	Unterprogramme zum Tapetimer Version 2.1					**********
;**********											**********
;**********	"Benutzte Register" sind nur Register in die geschrieben wird.			**********	
;*********************************************************************************************************

;*********************************************************************************************************
;**********	Umwandeln von gepacktem BCD in 5 stelliges Zeichenmuster			**********
;**********	benutzte Register: var10, z, anzeige[4:0]					**********
;*********************************************************************************************************
bcd2digit:
	mov	var10,tBCD2		;sichere BCD-Code Stelle 1
	rcall	hole_leuchtbild		;suche das entsprechende 7-Segmentmuster und
	sts	anzeige,var10		;schreibe es nach digit1
	mov	var10,tBCD1		;sichere BCD-Code Stelle 2 und 3
	swap	var10			;zuerst oberes Nibble
	rcall	hole_leuchtbild		;suche das entsprechende 7-Segmentmuster und
	sts	anzeige+1,var10		;schreibe es nach digit2
	mov	var10,tBCD1		;
	rcall	hole_leuchtbild		;usw.
	sts	anzeige+2,var10		;
	mov	var10,tBCD0		;
	swap	var10			;
	rcall	hole_leuchtbild		;
	sts	anzeige+3,var10		;
	mov	var10,tBCD0		;
	rcall	hole_leuchtbild		;
	sts	anzeige+4,var10		;
	ret

;*********************************************************************************************************
;**********	zur BCD-Zahl im Low-Nibble var10 den passenden 7-Segment-Code			**********
;**********	aus  der LookUpTable holen und in var10 bereithalten				**********
;**********	benutzte Register: var10, Z							**********
;*********************************************************************************************************
hole_leuchtbild:
	andi	var10,0b00001111	;unteres Nibble maskieren
	ldi	zh,byte2(tab_zeichen<<1);Zeiger auf Tabelle Siebensegmentzeichen
	mov	zl,var10		;und Nutzdaten direkt adressieren
	lpm	var10,z			;hole das Zeichen fr das Digit
	ret

;*********************************************************************************************************
;**********	Zustand der 2 Reflexlichtschranken in Bewegungsdaten umsetzen			**********
;**********	und damit die Zhlwerke fr Umdrehungen und Lagen bedienen			**********
;**********	bei Umdrehungszhlerstand 0000 im Spulmodus den Nullstoppausgang aktivieren	**********
;**********	benutzte Register: 								**********
;**********	var1[2:0], Z, Lagenzahl, Umdrehungszahl, lauf_impuls, stop_impuls, syncfenster	**********
;*********************************************************************************************************
hole_drehgeber:
	in	var10,pinb		;hole Eingangsstatus
	andi	var10,(1<<e_geber_b)|(1<<e_geber_a)	;maskiere Nutzdaten der Lichtschranken aus
	mov	var11,flags				;sichere Flags
	andi	var11,(1<<licht_b)|(1<<licht_a)		;maskiere alten Zustand der Lichtschranken aus
	or	var10,var11		;jetzt liegen alter und neuer Zustand rechtbndig in var10 vor
	bst	var10,E_Geber_A		;neuer Zustand wird alter Zustand
	bld	flags,licht_a		;im Flag-Register
	bst	var10,E_Geber_B		;
	bld	flags,licht_b		;
	ldi	zl,byte1(tab_geber<<1)	;Tabelle mit
	ldi	zh,byte2(tab_geber<<1)	;Drehgeber-Werten
	add	zl,var10		;Index addieren
	adc	zh,null			;
	lpm	var10,z			;Wert holen
	tst	var10			;0 = keine Bewegung/-1,1 = ein Schritt/2,3 kleine Bewegung
	brne	bewegung_vorhanden	;
	rjmp	ende_geberauswertung	;
bewegung_vorhanden:
	sts	laufwerkpuls,null	;Laufwerkherzschlag bedienen
	cpi	var10,1			;vorwrts?
	breq	vorwaerts		;
	cpi	var10,-1		;rckwrts?
	breq	rueckwaerts		;
	rjmp	ende_geberauswertung	;
vorwaerts:
	lds	var10,lagenzahl		;Lagenzhler 
	lds	var11,lagenzahl+1	;
	subi	var10,byte1(-1)		;ein Feld mehr
	sbci	var11,byte2(-1)		;
	cpi	var10,byte1(max_lagen*k_0+1)	;wenn das Kassettengehuse voll ist
	ldi	var12,byte2(max_lagen*k_0+1)	;k_0=zebra*2
	cpc	var11,var12		;
	brlo	lagen_vor_gueltig	;
	ldi	var10,byte1(max_lagen*k_0)	;Lagenzhler auf diesem Stand einfrieren
	ldi	var11,byte2(max_lagen*k_0)	;
lagen_vor_gueltig:
	sts	lagenzahl,var10		;
	sts	lagenzahl+1,var11	;		
	lds	var10,syncfenster	;Syncfenster bedienen
	lds	var11,syncfenster+1	;
	cpi	var10,byte1(max_syncfenster*k_0)
	ldi	var12,byte2(max_syncfenster*k_0)
	cpc	var11,var12		;
	brsh	umdrehung_vorwaerts	;zhlt bis 100 Umdrehungen
	subi	var10,byte1(-1)		;aufwrts
	sbci	var11,byte2(-1)		;
	sts	syncfenster,var10	;
	sts	syncfenster+1,var11	;
umdrehung_vorwaerts:
	lds	var10,umdrehungszahl	;hole Umdrehungszhler
	lds	var11,umdrehungszahl+1	;
	subi	var10,byte1(-1)		;ein Feld mehr
	sbci	var11,byte2(-1)		;
	cpi	var10,byte1(max_umdrehung*k_0)	;wenn berlauf erreicht
	ldi	var12,byte2(max_umdrehung*k_0)
	cpc	var11,var12		;
	brlo	umdrehung_gueltig	;
	clr	var10			;Umdrehungszhler rcksetzen
	clr	var11			;
	rjmp	teste_auf_nullstopp	;
rueckwaerts:
	lds	var10,lagenzahl		;Lagenzhler holen
	lds	var11,lagenzahl+1	;
	cp	var10,null		;negative Bandlagen gibt es nicht!
	cpc	var11,null		;
	breq	umdrehung_rueckwaerts	;
	subi	var10,byte1(1)		;wenn aber noch was auf dem Wickel ist
	sbci	var11,byte2(1)		;weiter abwickeln
	sts	lagenzahl,var10		;
	sts	lagenzahl+1,var11	;
umdrehung_rueckwaerts:
	lds	var10,umdrehungszahl	;hole Umdrehungszhler
	lds	var11,umdrehungszahl+1	;
	subi	var10,byte1(1)		;ein Feld weniger
	sbci	var11,byte2(1)		;
	cp	var10,null		;
	cpc	var11,null		;
	breq	teste_auf_nullstopp	;bei Zhlerstand 0
;teste_auf_unterlauf:
	cpi	var10,byte1(max_umdrehung*k_0)	;wenn Unterlauf erreicht ist
	ldi	var12,byte2(max_umdrehung*k_0)	;k_0=zebra*2
	cpc	var11,var12		;
	brlo	umdrehung_gueltig	;
	ldi	var10,byte1(max_umdrehung*k_0-1);Zhler rcksetzen
	ldi	var11,byte2(max_umdrehung*k_0-1);
	rjmp	umdrehung_gueltig	;
;*********************************************************************************************************
;**********	Nullstopausgang bedienen							**********
;*********************************************************************************************************
teste_auf_nullstopp:
	sbrs	flags,spulen		;nur im Spul-Modus
	rjmp	umdrehung_gueltig	;
	sbi	portb,a_stop		;Nullstopp-Ausgang aktivieren
	sts	stopimpuls,null		;Nullstopp-Impuls anfordern
umdrehung_gueltig:
	sts	umdrehungszahl,var10	;
	sts	umdrehungszahl+1,var11	;
ende_geberauswertung:
	ret

;*********************************************************************************************************
;**********	Capture-Event-Handler								**********
;**********	Abgelaufene Zeit zum letzten Zeitstempel ermitteln.				**********
;**********	Dauer bewerten und entsprechenden Laufwerkstatus signalisieren.			**********
;**********	benutzte Register: var1[3:0], Z, timsk, icr_alt, t_segm_akt, flags		**********
;*********************************************************************************************************
capture_event:
	in	var12,timsk		;
	cbr	var12,(1<<TICIE1)	;Timer 1 Capture Event IRQ kurz aussetzen
	out	timsk,var12		;fr atomaren Zugriff

	lds	var10,icr		;hole letzten Zeitstempel
	lds	var11,icr+1		;

	sbr	var12,(1<<TICIE1)	;
	out	timsk,var12		;

	lds	var12,icr_alt		;hole vorletzten Zeitstempel
	lds	var13,icr_alt+1		;
	sts	icr_alt,var10		;neuer Zeitstempel wird Alter
	sts	icr_alt+1,var11		;
	sub	var10,var12		;wieviel Counts sind seit letztem Zeitstempel vergangen?
	sbc	var11,var13		;ein berlauf braucht nicht bercksichtigt werden

	sts	t_segm_akt,var10	;merken
	sts	t_segm_akt+1,var11	;

	cpi	var10,byte1(min_cue)	;Impulsdauer zu klein um als Spulen zu gelten?
	ldi	var12,byte2(min_cue)	;(z.B. Glitches)
	cpc	var11,var12		;
	brlo	ende_capture_event	;dann raus

	cpi	var10,byte1(max_cue)	;Wert passend um als Spulen zu gelten?
	ldi	var12,byte2(max_cue)	;
	cpc	var11,var12		;
	brlo	maschine_spult		;dann bitte

	cpi	var10,byte1(min_play)	;Wert zu klein um als Wiedergabe zu gelten?
	ldi	var12,byte2(min_play)	;
	cpc	var11,var12		;
	brlo	ende_capture_event	;dann raus

	cpi	var10,byte1(max_play)	;Wert passend um als Wiedergabe zu gelten?
	ldi	var12,byte2(max_play)	;
	cpc	var11,var12		;
	brsh	ende_capture_event	;
;maschine_spielt:
	sbr	flags,(1<<wiedergabe)	;Laufwerkstatus signalisieren
	cbr	flags,(1<<spulen)|(1<<spulbeginn)
	rjmp	ende_capture_event	;
maschine_spult:				;
	cbr	flags,(1<<wiedergabe)	;Laufwerkstatus signalisieren
	sbrs	flags,spulen		;hat das Spulen jetzt erst angefangen?
	sbr	flags,(1<<spulbeginn)|(1<<spulen)
ende_capture_event:
	ret

;*********************************************************************************************************
;**********	Bei jeder Umdrehung des Aufwickeltellers im Wiedergabe oder Aufnahmebetrieb	**********
;**********	entstehen in var1[1:0] N = "Zebra" Messwerte, die in den Ringspeicher S		**********
;**********	bergeben werden.								**********
;**********	benutzte Register: var1[3:0], var2[1:0], Z, zeiger_s				**********
;*********************************************************************************************************
in_speicher_s:
	ldi	zl,byte1(speicher_s)	;Z auf Speicherbereich S stellen
	ldi	zh,byte2(speicher_s)	;

	lds	var12,zeiger_s		;aktuellen Zeiger holen
	lds	var13,zeiger_s+1	;

	add	zl,var12		;Z genau auf Speicherzellenpaar drehen
	adc	zh,var13		;

	lds	var10,t_segm_akt	;Segmentlaufzeit laden
	lds	var11,t_segm_akt+1	;

	st	z+,var10		;und Wert dort ablegen
	st	z+,var11		;

	subi	var12,byte1(-2)		;Einlesezeiger mit Schrittweite 2
	sbci	var13,byte2(-2)		;fr wortweises Adressieren mitfhren

	cpi	var12,byte1(k_1*2)	;k_1=zebra*(mittelwerttiefe+delta_s)
	ldi	var10,byte2(k_1*2)	;am Ende des Ringspeichers
	cpc	var13,var10		;
	brlo	zeiger_s_gueltig	;

	clr	var12			;wieder vorne beginnen
	clr	var13			;
zeiger_s_gueltig:
	sts	zeiger_s,var12		;Zeiger sichern
	sts	zeiger_s+1,var13	;

;*********************************************************************************************************
;**********	Diese Routine wird bei jedem neuen gltigen Messwert im Play aufgerufen.	**********
;**********	Das Auslesen der Messwerte geschieht aus 2 Bereichen des Ringspeichers S.	**********
;**********	Der Mittelwert der Messwerte in den Speicherzellen				**********
;**********		"(zeiger_s-1)-(zebra*Mittelwerttiefe)" bis "(zeiger_s-1)" wird nach	**********
;**********		"T_Segm" bergeben							**********
;**********	der Mittelwert der lteren Messwerte in den Speicherzellen			**********
;**********	"(zeiger_s-1)+(zebra*delta_s)" bis						**********
;**********	"(zeiger_s-1)+(zebra*(Mittelwerttiefe+Delta_s)" wird nach			**********
;**********	"t_segm_mittel" bergeben							**********
;*********************************************************************************************************
;**********	Mittelwert Segmentlaufzeit der letzten "Mittelwerttiefe*zebra" Werte bilden	**********
;**********	und nach T_Segm bergeben							**********
;**********	"(zeiger_s)-1" markiert die Speicherstelle mit dem zuletzt abgelegten Wert	**********
;**********	ist zeiger_s = 0 muss der bertrag addiert werden				**********
;*********************************************************************************************************
bilde_mittelwert_t:
	clr	mod0			;Ergebnisregister lschen
	clr	mod1			;
	clr	mod2			;

	ldi	var12,byte1(zebra*mittelwerttiefe)	;Schleifenzhler "Lesen" laden
	ldi	var13,byte2(zebra*mittelwerttiefe)	;

	ldi	zl,byte1(speicher_s)	;Zeiger Z mit Adresse Speicher S initialisieren
	ldi	zh,byte2(speicher_s)	;

	lds	var20,zeiger_s		;wo sind die neuesten Werte im Ringspeicher abgelegt?
	lds	var21,zeiger_s+1	;(Zeiger S wird wortweise gefhrt)

	cp	var20,null		;
	cpc	var21,null		;
	brne	zeiger_s_ungleich_null	;

	subi	var20,byte1(-k_1*2)	;
	sbci	var21,byte2(-k_1*2)	;k_1=zebra*(mittelwerttiefe+delta_s)
zeiger_s_ungleich_null:
	add	zl,var20		;Lesezeiger genau einstellen
	adc	zh,var21		;
summiere_s:
	cpi	zl,byte1(speicher_s)	;
	ldi	var10,byte2(speicher_s)	;
	cpc	zh,var10		;Anfang Speicherbereich erreicht?
	brne	kein_uebertrag_zeiger_s	;
	ldi	zl,byte1(speicher_s+k_1*2)	;dann Zeiger
	ldi	zh,byte2(speicher_s+k_1*2)	;rcksetzen
kein_uebertrag_zeiger_s:
	ld	var11,-z		;Zeiger jetzt eins runter und 16-Bit Zahl holen
	ld	var10,-z		;

	add	mod0,var10		;Wert aufsummieren
	adc	mod1,var11		;
	adc	mod2,null		;

	subi	var12,byte1(1)		;ein Wert mehr abgearbeitet
	sbci	var13,byte2(1)		;
	brne	summiere_s		;alle erforderlichen Werte schon zusammen?

	ldi	var10,mittelwerttiefe*zebra/2	
	add	mod0,var10		;dann runden
	adc	mod1,null		;
	adc	mod2,null		;

	lsr	mod2			;bei Zebra = 4
	ror	mod1			;durch 4 dividieren
	ror	mod0			;

	lsr	mod2			;
	ror	mod1			;
	ror	mod0			;
.if (zebra==8)
	lsr	mod2			;bei Zebra =8
	ror	mod1			;durch 8 Dividieren
	ror	mod0			;
.endif
.if (mittelwerttiefe==16)
	lsr	mod2			;bei Mittelwerttiefe = 16
	ror	mod1			;durch 16 dividieren
	ror	mod0			;
.endif
.if (mittelwerttiefe==16)|(mittelwerttiefe==8)
	lsr	mod2			;bei Mittelwerttiefe = 8
	ror	mod1			;durch 8 dividieren
	ror	mod0			;
.endif
.if (mittelwerttiefe==16)|(mittelwerttiefe==8)|(mittelwerttiefe==4)
	lsr	mod2			;bei Mittelwerttiefe = 4
	ror	mod1			;durch 4 dividieren
	ror	mod0			;
.endif
	lsr	mod2			;bei Mittelwerttiefe = 2
	ror	mod1			;durch 2 dividieren
	ror	mod0			;

	sts	t_segm,mod0		;
	sts	t_segm+1,mod1		;gewonnenen Mittelwert weglegen

;*********************************************************************************************************
;**********	von Speicherzelle "zeiger_s-(zebra*delta_s)" an rckwrts			**********
;**********	bis mittelwerttiefe*zebra Zellen abgearbeitet sind alle Werte aufsummieren,	**********
;**********	dividieren durch zebra*mittelwerttiefe und ablegen in "t_segm_mittel"		**********
;*********************************************************************************************************
bilde_mittelwert_t_delta:
	clr	mod0				;Ergebnisregister lschen
	clr	mod1				;
	clr	mod2				;
	ldi	var12,byte1(zebra*mittelwerttiefe)	;Schleifenzhler laden
	ldi	var13,byte2(zebra*mittelwerttiefe)	;
	ldi	zl,byte1(speicher_s)		;Zeiger Z auf Beginn Speicherbereich "S" stellen
	ldi	zh,byte2(speicher_s)		;
	lds	var20,zeiger_s			;wo ist der neueste Wert abgelegt?
	lds	var21,zeiger_s+1		;
	cp	var20,null			;wenn Zeiger_s = 0, also ganz unten, dann
	cpc	var21,null			;
	brne	zeiger_s_nicht_null		;
	subi	var20,byte1(-k_1*2)		;nach ganz oben drehen
	sbci	var21,byte2(-k_1*2)		;k_1=zebra*(mittelwerttiefe+delta_s)
zeiger_s_nicht_null:
;*********************************************************************************************************
;**********	hier muss der Offset eingebaut werden zum Ansprechen der			**********
;**********	delta_s alten Speicherzellen							**********
;**********	subtrahiere vom (Zeiger_s) 2*zebra*delta_s, wenn das kleiner speicher_s wrde,	**********
;**********	addiere vorher 2*zebra*(mittelwerttiefe+delta_s)				**********
;*********************************************************************************************************
	ldi	var22,byte1(2*zebra*delta_s)	;einmal delta_s laden
	ldi	var23,byte2(2*zebra*delta_s)	;
	cp	var20,var22			;kann ich ohne Unterlauf substrahieren?
	cpc	var21,var23			;
	brsh	kein_unterlauf_zeiger_s_delta	;ja, sonst vorher
	subi	var20,byte1(-k_1*2)		;den bertrag drauf
	sbci	var21,byte2(-k_1*2)		;k_1=zebra*(mittelwerttiefe+delta_s)
kein_unterlauf_zeiger_s_delta:
	subi	var20,byte1(delta_s*zebra*2)	;drehe Lesezeiger auf delta_s alte Messwerte
	sbci	var21,byte2(delta_s*zebra*2)	;
	add	zl,var20			;Zeiger genau einstellen
	adc	zh,var21			;
summiere_s_delta:
	cpi	zl,byte1(speicher_s)		;
	ldi	var10,byte2(speicher_s)		;
	cpc	zh,var10			;Anfang Speicherbereich erreicht?
	brne	kein_uebertrag_zeiger_s_delta	;
	ldi	zh,byte2(speicher_s+k_1*2)	;dann Zeiger
	ldi	zl,byte1(speicher_s+k_1*2)	;rcksetzen
kein_uebertrag_zeiger_s_delta:
	ld	var11,-z		;Zeiger eins runter und 16-Bit Zahl holen
	ld	var10,-z		;
	add	mod0,var10		;Wert aufsummieren
	adc	mod1,var11		;
	adc	mod2,null		;
	subi	var12,byte1(1)		;ein Wert mehr abgearbeitet
	sbci	var13,byte2(1)		;
	brne	summiere_s_delta	;alle erforderlichen Werte schon zusammen?

	ldi	var10,mittelwerttiefe*zebra/2	;dann runden
	add	mod0,var10			;
	adc	mod1,null			;
	adc	mod2,null			;

	lsr	mod2			;bei Zebra = 4
	ror	mod1			;durch 4 dividieren
	ror	mod0			;

	lsr	mod2			;
	ror	mod1			;
	ror	mod0			;
.if (zebra==8)
	lsr	mod2			;bei Zebra =8
	ror	mod1			;durch 8 Dividieren
	ror	mod0			;
.endif
.if (mittelwerttiefe==16)
	lsr	mod2			;bei Mittelwerttiefe = 16
	ror	mod1			;durch 16 dividieren
	ror	mod0			;
.endif
.if (mittelwerttiefe==16)|(mittelwerttiefe==8)
	lsr	mod2			;bei Mittelwerttiefe = 8
	ror	mod1			;durch 8 dividieren
	ror	mod0			;
.endif
.if (mittelwerttiefe==16)|(mittelwerttiefe==8)|(mittelwerttiefe==4)
	lsr	mod2			;bei Mittelwerttiefe = 4
	ror	mod1			;durch 4 dividieren
	ror	mod0			;
.endif
	lsr	mod2			;bei Mittelwerttiefe = 2
	ror	mod1			;durch 2 dividieren
	ror	mod0			;

	sts	t_segm_delta,mod0	;
	sts	t_segm_delta+1,mod1	;gewonnenen Mittelwert weglegen

	rcall	rechne_radius		;rechne den aktuellen Wickelradius

;*********************************************************************************************************
;**********	Banddickenwert ermitteln und gltige Werte im Speicher "Dicke" ablegen		**********
;**********	Formel:										**********
;**********	d = (T_segm-T_segm_vor_delta_Umdreh.)*Vo*Zebra*Teiler1/(2*Pi*Clk*delta_Umdreh)	**********
;**********	normiert zu:	Dickenzahl = (((T_segm - t_segm_mittel)*24772)/1024		**********
;**********	benutzte Register:	var1[3:0], T_segm, T_segm_delta, dicke			**********
;**********				var1[2:0], var2[2:0], mod[2:0], flags1 			**********
;*********************************************************************************************************
	lds	var10,t_segm		;letzten Geschwindigkeitsmittelwert laden
	lds	var11,t_segm+1		;
	lds	var12,t_segm_delta	;Geschwindigkeitsmittelwert delta_s Umdrehungen vorher laden
	lds	var13,t_segm_delta+1	;

	sub	var10,var12					;neu minus alt
	sbc	var11,var13					;(T_segm - T_segm_vor_delta_Umdrehungen)
	cpi	var10,byte1(max_dicke*delta_s*392699/k_2)	;k_2=zebra*bandgeschw*1000
	ldi	var12,byte2(max_dicke*delta_s*392699/k_2)	;K = 2*Pi*Clk/Teiler1
	cpc	var11,var12					;nicht erlaubte Werte aussortieren (hier 157)
	brsh	dicke_nicht_gueltig				;
	cpi	var10,byte1(min_dicke*delta_s*392699/k_2)
	ldi	var12,byte2(min_dicke*delta_s*392699/k_2)	;K = 2*Pi*Clk/Teiler1
	cpc	var11,var12					;(hier 66)
	brlo	dicke_nicht_gueltig				;

	sbr	flags1,(1<<dicke_valide)			;und dann eine gltige Banddicke "valide" melden

	ldi	var20,byte1(10*k_2/(delta_s*38349))		;(24772)
	ldi	var21,byte2(10*k_2/(delta_s*38349))		;K = 100*2*Pi*Clk/(Teiler1*1024)

	rcall	mul16u						;multiplizieren (t_segm - t_segm_mittel)*6193
;*********************************************************************************************************
;**********	ab hier bentige ich wegen des eingeschrnkten Wertebereiches nicht mehr alle Bytes	**
;*********************************************************************************************************
	mov	var10,mod1		;Ergebnis mit Division durch 256 umladen
	mov	var11,mod2		;
	mov	var12,mod3		;

	subi	var10,byte2(-2)		;Rundung vornehmen
	sbci	var11,byte3(-2)		;
	sbci	var12,byte4(-2)		;

	lsr	var12			;und nochmal durch 4 dividieren
	ror	var11			;
	ror	var10			;

	lsr	var12			;
	ror	var11			;
	ror	var10			;

	sts	dicke_roh,var10		;ungefilterten Wert bereithalten
	sts	dicke_roh+1,var11	;

	rjmp	in_filter_d		;Banddickenwert in den Filter bergeben
dicke_nicht_gueltig:
	cbr	flags1,(1<<dicke_valide)|(1<<dicke_stabil)
	rjmp	ende_filter_d		;
;*********************************************************************************************************
;**********	bernahme eines validen Banddickenwertes var1[1:0] in die Mittelwertbildung D	**********
;**********	die Mittelwertbildung geschieht in indexgefhrter Speichertiefe			**********
;**********	benutzte Register:								**********
;**********	var1[3:0], var2[3:0], mod[4:0], null, dicke[3:0], syncfenster			**********
;*********************************************************************************************************
in_filter_d:
;*********************************************************************************************************
;**********	Filtertiefen:    2^N fr Index N = 2 bis 16					**********
;*********************************************************************************************************
;setze_filterindex:
	sbrs	flags,synchron		;
	rjmp	nicht_synchron		;
nachsync:
	lds	var20,wickelradius	;nach der Synchronisiation
	lds	var21,wickelradius+1	;je nach Wickelradius
	cpi	var20,byte1(filterwechsel_3*100)
	ldi	var22,byte2(filterwechsel_3*100)
	cpc	var21,var22		;
	brlo	setze_index_4		;weiterverzweigen
	cpi	var20,byte1(filterwechsel_4*100)
	ldi	var22,byte2(filterwechsel_4*100)
	cpc	var21,var22		;
	brlo	setze_index_5		;weiterverzweigen
;setze_index_6:
	ldi	var12,filterindex_6	;nach Synchronisation ab Wickelradius sehr gro
	rjmp	ende_setze_index	;
setze_index_5:
	ldi	var12,filterindex_5	;nach Synchronisation ab Wickelradius gro
	rjmp	ende_setze_index	;
setze_index_4:
	ldi	var12,filterindex_4	;nach Synchronisation
	rjmp	ende_setze_index	;
nicht_synchron:
	lds	var12,syncfenster	;
	lds	var13,syncfenster+1	;

	cpi	var12,byte1(filterwechsel_1*k_0);k_0=zebra*2
	ldi	var20,byte2(filterwechsel_1*k_0);
	cpc	var13,var20		;
	brlo	setze_index_1		;

	cpi	var12,byte1(filterwechsel_2*k_0);
	ldi	var20,byte2(filterwechsel_2*k_0);
	cpc	var13,var20		;
	brlo	setze_index_2		;

	cpi	var12,byte1(max_syncfenster*k_0);bei gelschtem "Sync"-Flag
	ldi	var20,byte2(max_syncfenster*k_0);UND nach Ablauf des Syncfensters
	cpc	var13,var20			;wurde eine Nachsynchronisierung durchgefhrt
	breq	nachsync			;Filterindex bitte beibehalten
;setze_index_3:
	ldi	var12,filterindex_3	;nach Einschwingphase
	rjmp	ende_setze_index	;
setze_index_2:
	ldi	var12,filterindex_2	;zum Einschwingen
	rjmp	ende_setze_index	;
setze_index_1:
	ldi	var12,filterindex_1	;vor Synchronisation bis zum Einschwingen
ende_setze_index:

;*******  T E S T  **********************
;	ldi	var12,4			;feste Filtertiefe 16 (2^4) fr Kennlinienaufnahme von Kassetten
;*******  E N D E  **********************
	sts	filterindex,var12	;

	lds	var20,dicke		;hole Banddicke mit Nachkommastellen
	lds	var21,dicke+1		;
	lds	var22,dicke+2		;
	lds	var23,dicke+3		;

	mov	mod0,var20		;fr sptere Division umkopieren
	mov	mod1,var21		;
	mov	mod2,var22		;
	mov	mod3,var23		;
	mov	mod4,null		;

	mov	var13,var12		;
teile_speicher_d:
	dec	var13			;nun (index-1) mal mod[4:0] rechts schieben
	tst	var13			;
	breq	ende_teile_speicher_d	;

	lsr	mod4			;
	ror	mod3			;
	ror	mod2			;
	ror	mod1			;
	ror	mod0			;
	rjmp	teile_speicher_d	;
ende_teile_speicher_d:
	ldi	var13,1			;vor der letzten Division Rundung durchfhren
	add	mod0,var13		;
	adc	mod1,null		;
	adc	mod2,null		;
	adc	mod3,null		;
	adc	mod4,null		;

	lsr	mod4			;und ein letztes mal dividieren
	ror	mod3			;
	ror	mod2			;
	ror	mod1			;
	ror	mod0			;

	sub	var20,mod0		;ziehe den ermittelten Bruchteil Mittelwertes vom Speicherinhalt ab
	sbc	var21,mod1		;
	sbc	var22,mod2		;
	sbc	var23,mod3		;

	mov	mod0,null		;eingelaufenen Dickenwert fr sptere Division vorhalten
	mov	mod1,null		;
	mov	mod2,var10		;
	mov	mod3,var11		;
	mov	mod4,null		;
	mov	var13,var12		;
teile_wert_d:
	dec	var13			;nun (index-1) mal mod[4:0] rechts schieben
	tst	var13			;
	breq	ende_teile_wert_d	;

	lsr	mod4			;
	ror	mod3			;
	ror	mod2			;
	ror	mod1			;
	ror	mod0			;
	rjmp	teile_wert_d		;
ende_teile_wert_d:
	ldi	var13,1			;vor der letzten Division Rundung durchfhren
	add	mod0,var13		;
	adc	mod1,null		;
	adc	mod2,null		;
	adc	mod3,null		;
	adc	mod4,null		;

	lsr	mod4			;und ein letztes mal dividieren
	ror	mod3			;
	ror	mod2			;
	ror	mod1			;
	ror	mod0			;

	add	var20,mod0		;addiere den ermittelten Bruchteil des neuen Eingangswertes
	adc	var21,mod1		;zum Speicherinhalt U
	adc	var22,mod2		;
	adc	var23,mod3		;
;sichere_dicke:
	lds	var10,dicke		;sichere bisherigen Dickenwert
	lds	var11,dicke+1		;
	lds	var12,dicke+2		;
	lds	var13,dicke+3		;

	sts	dicke,var20		;neuen Mittelwert ablegen
	sts	dicke+1,var21		;
	sts	dicke+2,var22		;
	sts	dicke+3,var23		;

	cbr	flags1,(1<<dicke_negativ);Vorzeichenflag lschen

	sub	var20,var10		;wie ist der Differenz 
	sbc	var21,var11		;der beiden Werte, die einen Feldervorbeilauf auseinanderliegen
	sbc	var22,var12		;
	sbc	var23,var13		;
	brcc	u_ist_positiv		;bei negativem Ergebnis

	com	var23			;erhlt man den Absolutbetrag indem
	com	var22			;das Zweierkomplement gebildet und
	com	var21			;
	neg	var20			;
	sbci	var21,byte2(-1)		;1 dazu addiert wird
	sbci	var22,byte3(-1)		;
	sbci	var23,byte4(-1)		;

	sbr	flags1,(1<<dicke_negativ);Vorzeichen fr sptere Anzeige merken
u_ist_positiv:
	sts	dicke_delta,var20	;Wert fr Validierung weglegen
	sts	dicke_delta+1,var21	;
	sts	dicke_delta+2,var22	;
	sts	dicke_delta+3,var23	;

	mov	var20,var21		;Fr eine Anzeige den Wertebereich Umformen
	mov	var21,var22		;
	mov	var22,var23		;

	ldi	var10,byte1(1000)	;lade Multiplikator
	ldi	var11,byte2(1000)	;um 2 Nachkommastellen zu bekommen

	rcall	mul16x24u		;berlufe werden nicht bercksichtigt!

	sts	dicke_delta_anz,mod1	;dividieren durch 256
	sts	dicke_delta_anz+1,mod2	;und fr eine Anzeige bereithalten

ende_filter_d:
	ret

;*********************************************************************************************************
;**********	Dickenwert whrend der Synchronisierung nach jedem Capture-Event validieren,	**********
;**********	d.h. den Verlauf ber die Zeit bewerten. Abhngig vom Zeitfenster wird		**********
;**********	Validierung oder Synchronisation erlaubt oder erzwungen.			**********
;**********	Versuche mit variablem Fenster waren mit billigen Kassetten erfolglos.		**********
;**********	benutzte Register: var1[3:0], dicke_alt, dicke_delta, flags1			**********
;*********************************************************************************************************
validiere_speicher_u:
	lds	var10,syncfenster	;
	lds	var11,syncfenster+1	;
	cpi	var10,byte1(syncsperre*k_0)	;Fenster fr Validierung offen
	ldi	var12,byte2(syncsperre*k_0)	;k_0=zebra*2
	cpc	var11,var12		;
	brlo	kein_val_u		;nein

	cpi	var10,byte1(syncpflicht*k_0)	;Zeitpunkt fr Zwangssynchronisierung erreicht?
	ldi	var12,byte2(syncpflicht*k_0)	;
	cpc	var11,var12		;
	breq	u_ist_valide		;ja

	lds	var20,dicke_delta	;hole Ableitung Banddicke ber ein Feld
	lds	var21,dicke_delta+1	;
	lds	var22,dicke_delta+2	;
	lds	var23,dicke_delta+3	;

	cpi	var20,byte1(delta_u*65536/10)	;wenn die Banddicke noch zu sehr schwankt
	ldi	var10,byte2(delta_u*65536/10)	;
	cpc	var21,var10			;K=2^16/10
	ldi	var10,byte3(delta_u*65536/10)	;so komme ich mit "delta_d" genau auf die Banddicke in nm
	cpc	var22,var10			;
	ldi	var10,byte4(delta_u*65536/10)	;
	cpc	var23,var10			;
	brsh	kein_val_u		;warten, sonst
	lds	var10,zaehler_dicke	;
	inc	var10			;"Beruhigungsphase Banddicke" + 1 Feld
	sts	zaehler_dicke,var10	;sichern
	cpi	var10,(delta_t*zebra)	;wenn Banddicke lnger stabil war
	brlo	ende_val_u		;
u_ist_valide:
	sbr	flags1,(1<<dicke_stabil);gib grnes Licht zur Zeitrechnung

;*******  nicht produktiv  *******************************************************************************
;	lds	var10,dicke+2		;Banddicke fr eine Speicherinitialisierung weglegen
;	lds	var11,dicke+3		;
;	sts	dicke_init,var10	;
;	sts	dicke_init+1,var11	;
;*******  nicht produktiv  *******************************************************************************

kein_val_u:
	sts	zaehler_dicke,null	;Zhler "Beruhigungsphase Banddicke" rcksetzen
ende_val_u:
	ret

;*********************************************************************************************************
;**********	Errechne die aufgespulten Lagen							**********
;**********	Grundformel: counts = r * 2 * Pi * CLK/(Vo * Weifelderzahl * Vorteiler1)	**********
;**********	entspricht: R_aktuell = T_segm * V_o * Zebra * Vorteiler_1/(Pi * 2 * CLK)	**********
;**********	Weiter gilt: Lagen = (Radius_aktuell - Kernradius)/Banddicke			**********
;**********	Beide Gleichung zusammengefhrt und fr den Controller umgeformt zu:		**********
;**********	Lagenzahl = (T_segm*24772/256-100*Kernradius)*2*Zebra/Dickenwert		**********
;**********			                                          			**********
;**********	bentigte Register: alle! :-)							**********
;*********************************************************************************************************
lagen_absolut:
;rechne Term A: T_Segm*24772/256 = scratch[2:0]

	lds	var10,T_Segm		;lade Tellerdrehzahl
	lds	var11,T_Segm+1		;

	ldi	var20,byte1(k_2/15340+1);k_2=zebra*bandgeschw*1000
	ldi	var21,byte2(k_2/15340+1);K = 2*Pi*CLK/(Teiler_1*256) Teiler_1=64

	rcall	mul16u			;rechne: "T_segm * 24772"

	mov	var10,mod0		;Zwischenergebnis umladen
	mov	var11,mod1		;
	mov	var12,mod2		;
	mov	var13,mod3		;

;*******  P R  F E N  ******************
;	subi	var10,byte1(-128)	;runden
;	sbci	var11,byte2(-128)	;
;	sbci	var12,byte3(-128)	;
;	sbci	var13,byte4(-128)	;
;*******  E N D E  **********************

	sts	scratch,var11		;weglassen des LowByte ist die Division durch 256
	sts	scratch+1,var12		;
	sts	scratch+2,var13		;Zwischenergebnis nach scratch[2:0] weglegen

;rechne Term B: 100*Kernradius-Dickenwert/2 = var2[3:0]

	lds	var20,Kernradius	;hole Kernradius * 100
	lds	var21,Kernradius+1	;
	lds	var22,Kernradius+2	;
	ldi	var23,0			;

	lds	var10,dicke+2		;hole Dickenwert
	lds	var11,dicke+3		;

	subi	var10,byte1(-1)		;runden: "+ 1"
	sbci	var11,byte2(-1)		;

	lsr	var11			;rechne: "/ 2"
	ror	var10			;

	sub	var20,var10		;rechne: "(100 * Kernradius) - Dickenwert/2"
	sbc	var21,var11		;
	sbc	var22,null		;
;	sbc	var23,null		;

	lds	var10,scratch		;hole Zwischenergebnis A
	lds	var11,scratch+1		;
	lds	var12,scratch+2		;
	ldi	var13,0			;

	cp	var10,var20		;A < B ? dann ist der gemessene Wickelradius kleiner
	cpc	var11,var21		;als der Bobbyradius und es wrde eine negative
	cpc	var12,var22		;Lagenzahl errechnet werden, was nicht erlaubt ist
;	cpc	var13,var23		;
	brsh	rechne_A_minus_B	;
	rjmp	ende_lagen_absolut	;dann raus hier, die adaptive Kernradiusermittlung wird das klren, sonst

rechne_A_minus_B:
;rechne A - B = C
;scratch[2:0] - var2[2:0] = var1[2:0]

	sub	var10,var20		;rechne: "A - B"
	sbc	var11,var21		;
	sbc	var12,var22		;
;	sbc	var13,var23		;

	lsl	var10			;das Zwischenergebnis mit
	rol	var11			;
	rol	var12			;2 * Zebra multiplizieren
	rol	var13			;

	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;

	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;
.if (zebra==8)
	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;
.endif
	
;rechne C / dicke
;var1[3:0] / dicke
;vor der Division Rundung vornehmen

	lds	var20,dicke+2		;hole Dickenwert
	lds	var21,dicke+3		;

	subi	var20,byte1(-1)		;runden
	sbci	var21,byte2(-1)		;

	lsr	var21			;rechne: "/ 2"
	ror	var20			;

	add	var10,var20		;und zwecks Rundung zum Dividend addieren
	adc	var11,var21		;
	adc	var12,null		;bertrag bercksichtigen
	adc	var13,null		;auch frs MSB

	lds	var20,dicke+2		;hole Dickenwert
	lds	var21,dicke+3		;
	ldi	var22,0			;
	ldi	var23,0			;

	rcall	div32u			;rechne: "C / Dickenwert"

;*********************************************************************************************************
;**********	die errechneten Lagen sind mit einem Offset behaftet, da der zugrundeliegende	**********
;**********	Radius_aktuell durch die Mittelwertbildung immer eine Verzgerung von		**********
;**********	Mittelwerttiefe/2 aufweist. Die Korrektur folgt jetzt:				**********
;*********************************************************************************************************
	subi	var10,byte1(-Mittelwerttiefe/2)
	sbci	var11,byte2(-Mittelwerttiefe/2)

	cpi	var10,byte1(max_lagen*k_0+1)	;wenn erlaubter Breich verlassen werden soll
	ldi	var12,byte2(max_lagen*k_0+1)	;k_0=zebra*2
	cpc	var11,var12			;
	brlo	lagen_absolut_gueltig		;
	ldi	var10,byte1(max_lagen*k_0)	;Lagenzhler begrenzen
	ldi	var11,byte2(max_lagen*k_0)	;
lagen_absolut_gueltig:
	sts	lagenzahl,var10		;gerechnete Lagenzahl sichern
	sts	lagenzahl+1,var11	;
ende_lagen_absolut:
	ret

;*********************************************************************************************************
;**********	Berechnung einer Lagenzahl, die zur im Display angezeigten Zeit passt um zu	**********
;**********	verhindern, dass die Zeitanzeige bei Spulbeginn springt.			**********
;**********	Grundformel: T = (2 * PI * Lagen * (R_o + (Lagen + 1) * (Banddicke/2))) / V_o	**********
;**********	aufgelst nach Lagen								**********
;**********	L = (Wurzel((Banddicke/2+Ro)^2+T*Banddicke*Vo/Pi)-Banddicke/2-Ro)/Banddicke	**********
;**********	Gleichung fr den Controller umgeformt und normiert zu:				**********
;**********	Lagen = (64*Wurzel(((Dickenwert/2+100*Kernradius)/64)^2+Dickenwert*T*369)-	**********
;**********	Fortsetzung von oben: (Dickenwert/2+100*Kernradius))/Dickenwert			**********
;**********	bentigte Register:	var1[3:0], var2[3:0], lc, lagenzahl, dicke[3:2]		**********
;**********				Zeit_anz, scratch[3:0], scratch1[2:0], mod[4:0]		**********
;*********************************************************************************************************
setze_lagenzahl:
;rechne Term A: dicke/2+100*Kernradius = scratch1[2:0]

	lds	var10,dicke+2		;hole Dickenwert
	lds	var11,dicke+3		;

	subi	var10,byte1(-1)		;runden
	sbci	var11,byte2(-1)		;

	lsr	var11			;rechne: "Dickenwert / 2"
	ror	var10			;

	lds	var20,Kernradius	;lade 100*Kernradius
	lds	var21,Kernradius+1	;
	lds	var22,Kernradius+2	;

	add	var20,var10		;rechne: "Dickenwert / 2 + 100 * Kernradius"
	adc	var21,var11		;
	adc	var22,null		;bertrag bercksichtigen

	sts	scratch1,var20		;Zwischenergebnis nach "scratch1" weglegen
	sts	scratch1+1,var21	;
	sts	scratch1+2,var22	;

;rechne Term B: (Term A/64)^2 = scratch[3:0]

	subi	var20,byte1(-32)	;runden
	sbci	var21,byte2(-32)	;
	sbci	var22,byte3(-32)	;

	lsl	var20			;rechne: "(Dickenwert / 2 + 100 * Kernradius) / 64"
	rol	var21			;
	rol	var22			;indem mit 4 multipliziert wird

	lsl	var20			;und das niederwertigste Byte "var20 "entfllt
	rol	var21			;
	rol	var22			;

	mov	var10,var21		;Operanden fr Quadrierung laden
	mov	var11,var22		;
	mov	var20,var21		;
	mov	var21,var22		;

	rcall	mul16u			;rechne: "((Dicke / 2 + 100 * Kernradius) / 64)^2"

	sts	scratch,mod0		;Zwischenergebnis nach "Scratch" weglegen
	sts	scratch+1,mod1		;
	sts	scratch+2,mod2		;
	sts	scratch+3,mod3		;

;rechne Term C: dicke*T*369 = mod[3:0]

	lds	var10,dicke+2		;hole Dickenwert
	lds	var11,dicke+3		;

	ldi	var20,byte1(bandgeschw*100/12868)	;lade Multiplikator
	ldi	var21,byte2(bandgeschw*100/12868)	;K = (16*Pi*256)

	rcall	mul16u			;rechne: "Dickenwert * 369" = mod[3:0]

	mov	var20,mod0		;Ergebnis, 20Bit breit, fr Weiterverarbeitung umladen
	mov	var21,mod1		;
	mov	var22,mod2		;

	lds	var10,zeit_quartz	;hole Quarzzeit im Display, 12Bit breit
	lds	var11,zeit_quartz+1	;

	rcall	mul16x24u		;rechne: "Dickenwert * T * 369" = mod[3:0]

;rechne Term D: Wurzel(Term B+Term C) = mod[3:0]

	lds	var10,scratch		;hole "((Dickenwert / 2 + 100 * Kernradius) / 64)^2"
	lds	var11,scratch+1		;
	lds	var12,scratch+2		;
	lds	var13,scratch+3		;

	add	mod0,var10		;rechne: "((Dickenwert / 2 + 100 * Kernradius) / 64)^2
	adc	mod1,var11		;         + Dickenwert * T * 369"
	adc	mod2,var12		;
	adc	mod3,var13		;

	rcall	Sqrt32			;davon die Quadratwurzel ziehen = var1[1:0]

;*********************************************************************************************************
;**********	Durch Umstellung der Grundformel und Einengung des Wertebereiches auf Integer	**********
;**********	ist im vorhergehenden nicht gewhrleistet, dass fr den Eingangswert T = 0	**********
;**********	Sekunden die resultierende Restformel: 64 * Wurzel((x / 64)^2) = x aufgeht.	**********
;**********	Daher wird nachfolgende Korrektur vorgenommen					**********
;*********************************************************************************************************
	subi	var10,byte1(-1)		;Korrektur
	sbci	var11,byte2(-1)		;

;rechne Term E: D*64 = var1[2:0]

	mov	var12,var11		;Ergebnis mit 64 multiplizieren indem ich
	mov	var11,var10		;
	clr	var10			;mit 256 multipliziere und

	lsr	var12			;durch 4 dividieren
	ror	var11			;
	ror	var10			;

	lsr	var12			;
	ror	var11			;
	ror	var10			;

;rechne Term F: (Term E-Term A)/dicke = var1[1:0]

	lds	var20,scratch1		;hole "Dickenwert / 2 + 100 * Kernradius"
	lds	var21,scratch1+1	;
	lds	var22,scratch1+2	;

	sub	var10,var20		;rechne:
	sbc	var11,var21		;"64*Wurzel(((Dickenwert/2+100*Kernradius)/64)^2+Dickenwert*T*369)
	sbc	var12,var22		;   -(Dickenwert/2+100*Kernradius)"
	clr	var13			;

;hier keine Rundung vornehmen!
;mit 2 * zebra multiplizieren holt die ntigen Nachkommastellen nach vorne

	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;

	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;

	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;
.if (zebra==8)
	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;
.endif
	lds	var20,dicke+2		;hole Divisor "Dickenwert"
	lds	var21,dicke+3		;
	ldi	var22,0			;
	ldi	var23,0			;

	rcall	div32u			;dividiere dann alles

	sts	lagenzahl,var10		;sichere Ergebnis
	sts	lagenzahl+1,var11	;
	ret

;*********************************************************************************************************
;**********	Errechne die Abgespielte Zeit t_calc in Sekunden nach der Formel:		**********
;**********		T = (2 * PI * Lagen * (R_o + (Lagen + 1) * Banddicke/2)) / V_o		**********
;**********	Gleichung fr Lagenzahl angepasst zu:						**********
;**********		T = (2*PI*Lagenzahl*(R_o+(Lagen+1)*Banddicke/2))/(V_o*2*zebra)		**********
;**********	Fr den Controller umgeformt und normiert zu:					**********
;**********	T = (Lagenzahl*(100*Kernradius+((Lagenzahl/(2*zebra)+1)*Dickenwert/2)))/K	**********
;**********	K = 2*zebra*bandgeschw*1000/(20*PI)						**********
;*********************************************************************************************************
sekunden_absolut:
	lds	var10,lagenzahl		;hole Lagenzahl
	lds	var11,lagenzahl+1	;

	lsr	var11			;aus der Lagenzahl die wirklichen Bandlagen ermitteln
	ror	var10			;
	lsr	var11			;
	ror	var10			;
	lsr	var11			;
	ror	var10			;
.if (zebra==8)
	lsr	var11			;
	ror	var10			;
.endif
	subi	var10,byte1(-1)		;rechne: "Lagen + 1"
	sbci	var11,byte2(-1)		;

	lds	var20,dicke+2		;lade Dickenwert
	lds	var21,dicke+3		;

	rcall	mul16u			;rechne: "(Lagen + 1) * Dickenwert"

	lsr	mod2			;rechne: "(Lagen + 1) * Dickenwert / 2"
	ror	mod1			;
	ror	mod0			;(max. 31 * 2^16) mod3 ist immer 0

	lds	var20,Kernradius	;lade 100 * Kernradius
	lds	var21,Kernradius+1	;
	lds	var22,Kernradius+2	;(max. 17 * 2^16)

	add	var20,mod0		;rechne: "(Lagen + 1) * Dickenwert / 2 + 100 * Kernradius"
	adc	var21,mod1		;
	adc	var22,mod2		;(max. 50 * 2^16)

	lds	var10,lagenzahl		;hole Lagenzahl
	lds	var11,lagenzahl+1	;

	rcall	mul16x24u		;rechne: "Lagenzahl * ((Lagen + 1) * Dickenwert / 2 + 100 * Kernradius)"

	ldi	var20,byte1(k_2/4117748);Rundungsoperanden laden (92)
	ldi	var21,byte2(k_2/4117748);k_2=zebra*bandgeschw*1000
	ldi	var22,byte3(k_2/4117748);K = 20*PI*2^16

	add	var20,mod2		;rechne: "Lagenzahl * (((Lagen + 1) * Dickenwert / 2 + 100 * Kernradius))
	adc	var21,mod3		;         / 2^16"
	adc	var22,mod4		;

;**********  das Zwischenergebnis nun durch "2*zebra*bandgeschw*1000/(20*PI*2^16)" teilen (184,567)

	ldi	var10,byte1(45450)	;Multiplikator laden
	ldi	var11,byte2(45450)	;K = 10*PI*2^16*2^23/(zebra*bandgeschw*1000)

	rcall	mul16x24u		;rechne: "(Lagen * (((Lagen + 1) * Dickenwert / 2 + 100 * Kernradius)) * K)
					;
	lsl	mod2			;
	rol	mod3			;
	rol	mod4			;

	mov	var10,mod3		;"/ 2^23"
	mov	var11,mod4		;

	cpi	var10,byte1(max_sekunden+1)	;wenn der erlaubte Bereich verlassen werden soll
	ldi	var12,byte2(max_sekunden+1)	;
	cpc	var11,var12			;
	brlo	sekunden_gueltig		;
	ldi	var10,byte1(max_sekunden)	;Sekundenzhler auf Maximum begrenzen
	ldi	var11,byte2(max_sekunden)	;
sekunden_gueltig:
	sts	zeit_calc,var10		;Sekunden sichern
	sts	zeit_calc+1,var11	;
	ret

;*********************************************************************************************************
;**********	Die errechnete abgespielte Zeit wird an die Anzeige bergeben			**********
;**********	benutzte Register: var1[1:0], zeit_calc, zeit_anz				**********
;*********************************************************************************************************
uebergebe_zeit:
	lds	var10,zeit_calc		;neue gerechnete Zeit
	lds	var11,zeit_calc+1	;
	sts	zeit_quartz,var10	;geht aufs Display
	sts	zeit_quartz+1,var11	;
	ret

;*********************************************************************************************************
;**********	Wird im "Play" einmal pro Sekunde aufgerufen (Framezhler steht dabei auf 0)	**********
;**********	und addiert eine Sekunde auf die Zeitanzeige.					**********
;**********	Fhrt die Quarzzeit an den gerechneten Wert heran.				**********
;**********	Wenn noch nicht synchron, in einem Ruck, sonst sukzessive.			**********
;**********	Ich schiebe dazu den Framezhler in die entsprechende Richtung.			**********
;**********	Das ist nicht ganz sauber gelst, da damit die Zeitbasis der ganzen		**********
;**********	Anwendung auch geschoben wird.							**********
;**********	Die Zeitnachfhrung wird nach Spulen bei synchron kurz ausgesetzt.		**********
;**********	benutzte Register: zeit_anz, var1[3:0], var2[3:0], zeit_calc, zeit_fehler	**********
;**********	flags1, frame									**********
;*********************************************************************************************************
synchronisiere_zeit:
	sts	trimmanzeige,null	;kein Symbol fr sptere Trimmanzeige
	clr	var11			;Register fr Trimmwert lschen
	sbrs	flags,synchron		;bis zur Synchronisierung
	rjmp	sync_zeit		;stur die Quarzzeit zhlen

	lds	var12,syncfenster	;nach einem Spulvorgang
	lds	var13,syncfenster+1	;

	cpi	var12,byte1(syncsperre_kurz*k_0)	;kurz
	ldi	var20,byte2(syncsperre_kurz*k_0)	;k_0=zebra*2
	cpc	var13,var20		;
	brsh	label_1			;
	rjmp	sync_zeit		;die Zeitnachfhrung aussetzen
label_1:
	lds	var22,zeit_delta	;hole Ist-Abweichung
	lds	var23,zeit_delta+1	;

	lds	var10,zeit_quartz	;hole die Laufzeit aus der Anzeige
	lds	var11,zeit_quartz+1	;
	lds	var20,zeit_calc		;hole die errechnete Laufzeit
	lds	var21,zeit_calc+1	;

	sub	var10,var20		;bilde die Differenz
	sbc	var11,var21		;
	brcc	delta_zeit_positiv	;
;delta_zeit_negativ:
	com	var11			;Betrag bilden
	neg	var10			;
	sbci	var11,byte2(-1)		;
;*********************************************************************************************************
;**********	Sollvorzeichen ist negativ							**********
;*********************************************************************************************************
	sbrc	flags1,zeit_negativ	;wenn Istvorzeichen auch negativ, dann
	rjmp	ziehe_ist_abweichung	;Istwert an Sollwert nachfhren
;*********************************************************************************************************
;**********	Sollvorzeichen ist negativ und Istvorzeichen ist positiv 			**********
;*********************************************************************************************************
	cp	var22,null		;
	cpc	var23,null		;
	breq	label_2			;wenn Istwert 0, Istvorzeichen + setzen
	subi	var22,byte1(1)		;
	sbci	var23,byte2(1)		;Istwert einen Schritt absenken
	rjmp	ende_delta_zeit		;und fertig
label_2:
	sbr	flags1,(1<<zeit_negativ);Vorzeichen positiv und
	rjmp	ziehe_ist_abweichung	;Istwert an Sollwert ziehen
delta_zeit_positiv:
;*********************************************************************************************************
;**********	Sollvorzeichen ist positiv							**********
;*********************************************************************************************************
	sbrs	flags1,zeit_negativ	;wenn Istvorzeichen auch positiv, dann
	rjmp	ziehe_ist_abweichung	;Istwert an Sollwert nachfhren
;*********************************************************************************************************
;**********	Sollvorzeichen ist positiv und Istvorzeichen ist negativ			**********
;*********************************************************************************************************
	cp	var22,null		;
	cpc	var23,null		;
	breq	label_3			;wenn Istwert 0, Istvorzeichen + setzen
	subi	var22,byte1(1)		;
	sbci	var23,byte2(1)		;Istwert einen Schritt absenken
	cp	var22,null		;
	cpc	var23,null		;
	brne	ende_delta_zeit		;und fertig
	cbr	flags1,(1<<zeit_negativ);Vorzeichen positiv und
	rjmp	ende_delta_zeit		;
label_3:
	cbr	flags1,(1<<zeit_negativ);Vorzeichen positiv und
ziehe_ist_abweichung:
	cp	var22,var10		;mit Sollwert vergleichen
	cpc	var23,var11		;
	breq	ende_delta_zeit		;wenn identisch, fertig
	brlo	label_4			;

	subi	var22,byte1(1)		;Istwert negativ nachziehen
	sbci	var23,byte2(1)		;
	rjmp	ende_delta_zeit		;
label_4:
	subi	var22,byte1(-1)		;Istwert positiv nachziehen
	sbci	var23,byte2(-1)		;

	cpi	var22,byte1(1000)	;Werte > 999 abfangen
	ldi	var20,byte2(1000)	;
	cpc	var23,var20		;
	brlo	ende_delta_zeit		;
	ldi	var22,byte1(999)	;
	ldi	var23,byte2(999)	;
ende_delta_zeit:
	sts	zeit_delta,var22	;sichere Betrag der Zeitabweichung in Sekunden
	sts	zeit_delta+1,var23	;

	tst	var23			;Abweichungen grer 255
	breq	abw_bis_255		;
	ldi	var22,byte1(255)	;wie 255 behandeln, um innerhalb der Tabelle zu bleiben
	ldi	var23,byte2(255)	;
abw_bis_255:
;*********************************************************************************************************
;**********	Prfung auf Nachsynchronisierung						**********
;*********************************************************************************************************
	sbrc	flags1,resync		;Nachsynchronisierung ist nur einmal nach
	rjmp	kein_nachsync		;Kassettenwechsel erlaubt (die offene Klappe lscht das Flag)

	cpi	var10,delta_resync	;bei einer greren Zeitabweichung (hier 2 Minuten)
	brlo	kein_nachsync		;

	cpi	var12,byte1(max_Syncfenster*k_0);UND nach Ablauf des Syncfensters
	ldi	var20,byte2(max_Syncfenster*k_0)
	cpc	var13,var20		;
	brlo	kein_nachsync		;

	cbr	flags,(1<<synchron)	;wird eine Nachsynchronisierung angefordert
	sbr	flags1,(1<<resync)	;
kein_nachsync:
	ldi	zh,byte2(tab_zeitkorrektur<<1)	;Zeiger auf Tabelle Zeitkorrektur
	mov	zl,var22		;und Nutzdaten direkt adressieren
	lpm	var10,z			;Wert holen
	tst	var10			;wenn eine Trimmung erforderlich ist
	breq	sync_zeit		;fertig
	sbrc	flags1,zeit_negativ	;bei vorlaufender Zeit
	rjmp	zeitabw_negativ		;
;zeitabw positiv:
	sub	var11,var10		;Uhrwerk abbremsen
	ldi	var10,(1<<Seg_d)	;
	sts	trimmanzeige,var10	;
	rjmp	sync_zeit		;
zeitabw_negativ:
	add	var11,var10		;Uhrwerk beschleunigen
	ldi	var10,(1<<Seg_a)	;
	sts	trimmanzeige,var10	;
sync_zeit:
	sts	frame,var11		;Framezhler manipulieren
	lds	var10,zeit_quartz	;
	lds	var11,zeit_quartz+1	;
	subi	var10,byte1(-1)		;eine quarzgenaue Sekunde mehr
	sbci	var11,byte2(-1)		;
	sts	zeit_quartz,var10	;fr die Anzeige
	sts	zeit_quartz+1,var11	;
	ret

;*********************************************************************************************************
;**********	aus der Segmentlaufzeit den Wickelradius berechnen und den			**********
;**********	100.000-fachen Wickelradius fr weitergehende Rechnung bereithalten		**********
;**********	Ist der gemessene Wickelradius kleiner als der Defaultkernradius und		**********
;**********	grer als der Minimumkernradius, dann bergebe diesen als neuen Kernradius	**********
;**********	Formel: r = counts * Vo * Zebra * Teiler1/(2 * Pi * CLK)			**********
;**********	fr den Controller umgeformt und normiert zu:					**********
;**********	Radiuszahl = T_Segm*((Zebra*Bandgeschw*100/1534)/256)*16777/2^24		**********
;**********	benutzte Register: var1[2:0], var2[2:0], mod[4:0], Radius, T_Segm		**********
;*********************************************************************************************************
rechne_radius:
	lds	var10,t_segm		;hole letzten ruhigen Geschwindigkeitwert
	lds	var11,t_segm+1		;

	ldi	var20,byte1((k_2+7670)/15340)	;k_2=zebra*bandgeschw*1000
	ldi	var21,byte2((k_2+7670)/15340)	;K = 2*Pi*CLK/(Teiler1*256)
					;ermittle Wickelradius * 256*100.000
	rcall	mul16u			;"T-Segm * Zebra * 3097/256" = mod[3:0]

	mov	var20,mod1		;und sichere den 256sten Teil (=100*Wickelradius)
	mov	var21,mod2		;
	mov	var22,mod3		;
	mov	var23,mod0		;die "Nachkommastellen" fr die Rundung merken

	sbrs	flags2,kern_variabel	;ohne adaptive Kernradiusermittlung
	rjmp	kernradius_gueltig	;hier fertig

;*********************************************************************************************************
;**********	der Wickelradius wird nicht aus der aktuellen Tellerdrehzahl sondern		**********
;**********	aus dem Durchschnitt ber "Mittelwerttiefe" Umdrehungen ermittelt		**********
;**********	das ergibt einen Offset zum hier ermittelten Kernradius von:			**********
;**********	-Mittelwerttiefe*Banddicke/2 und zum aktuellen Wickelradius von:		**********
;**********	+Mittelwerttiefe*Banddicke/2							**********
;**********	Da die Banddicke am Bandanfang nie bekannt ist, Defaultwert anwenden		**********
;*********************************************************************************************************
	subi	var20,byte1(mittelwerttiefe*def_dicke/20)
	sbci	var21,byte2(mittelwerttiefe*def_dicke/20)
	sbci	var22,byte3(mittelwerttiefe*def_dicke/20)

	ldi	var10,byte1(min_Kern*100)	;lade kleinsten erlaubten
	ldi	var11,byte2(min_Kern*100)	;Kernradius (10800)
	ldi	var12,byte3(min_Kern*100)	;

	cp	var20,var10		;ist der gemessene Wickelradius kleiner als erlaubt
	cpc	var21,var11		;
	cpc	var22,var12		;
	brlo	kernradius_gueltig	;dann raus hier

	lds	var10,kernradius	;lade aktuellen Kernradius
	lds	var11,kernradius+1	;
	lds	var12,kernradius+2	;

	cp	var20,var10		;und kleiner als der aktuelle eingestellte Kernradius
	cpc	var21,var11		;
	cpc	var22,var12		;
	brsh	kernradius_gueltig	;

	sts	kernradius,var20	;bergebe diesen Wickelradius als neuen Kernradius
	sts	kernradius+1,var21	;
	sts	kernradius+2,var22	;
kernradius_gueltig:

;*********************************************************************************************************
;**********	Den Offset vom oben gerechneten Wickelradius rckgngig machen und in		**********
;**********	die andere Richtung anwenden, gleichzeitig schon runden				**********
;**********	das hier wieder draufaddieren: (mittelwerttiefe*def_dicke/10)+500		**********
;**********	Das Anwenden der Default Banddicke statt der aktuellen Dicke vereinfacht	**********
;**********	die Sache und ergibt einen fr diese Anzeige vernachlssigbaren Fehler		**********
;*********************************************************************************************************

	subi	var23,byte1(-((mittelwerttiefe*def_dicke*256/10)+500))	;da ich noch ein Nachkommabyte
	sbci	var20,byte2(-((mittelwerttiefe*def_dicke*256/10)+500))	;habe Faktor *256 anwenden
	sbci	var21,byte3(-((mittelwerttiefe*def_dicke*256/10)+500))
	sbci	var22,byte4(-((mittelwerttiefe*def_dicke*256/10)+500))

	ldi	var10,byte1(16777)	;lade Multiplikator
	ldi	var11,byte2(16777)	;K = 2^24/1000

	rcall	mul16x24u		;

	sts	wickelradius,mod3	;sichere den 2^24sten Teil
	sts	wickelradius+1,mod4	;
	ret

;*********************************************************************************************************
;**********	beim Spulen aus Lagenzahl und Banddicke den Wickelradius berechnen		**********
;**********	Formel: r = Kernradius + lagen * banddicke		 			**********
;**********	fr den Controller umgeformt und normiert zu:					**********
;**********	Radiuszahl = (Kernradius*100*2*zebra+lagenzahl*dickenzahl)*16777/(2^16*2*Zebra)	**********
;**********	benutzte Register: var1[3:0], var2[2:0], mod[3:0], kernradius, dicke, lagen	**********
;*********************************************************************************************************
zaehle_radius:
	lds	var10,dicke+2		;lade Banddicke Ganzzahlanteil
	lds	var11,dicke+3		;

	lds	var20,lagenzahl		;lade Lagenzahl
	lds	var21,lagenzahl+1	;

	rcall	mul16u			;rechne: "Lagenzahl * Dickenzahl"

	lds	var10,Kernradius	;lade Kernradius * 100
	lds	var11,Kernradius+1	;
	lds	var12,Kernradius+2	;
	ldi	var13,0			;Register lschen

	lsl	var10			;rechne Kernradius * 100 * 2 * Zebra
	rol	var11			;
	rol	var12			;
	rol	var13			;

	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;

	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;
.if (zebra==8)
	lsl	var10			;
	rol	var11			;
	rol	var12			;
	rol	var13			;
.endif
	add	var10,mod0		;rechne: "Kernradius * 100 * 2 * Zebra + lagenzahl * dickenzahl"
	adc	var11,mod1		;
	adc	var12,mod2		;
	adc	var13,mod3		;bertrag bercksichtigen

	subi	var10,byte1(-128*zebra)	;runden
	sbci	var11,byte2(-128*zebra)	;
	sbci	var12,byte3(-128*zebra)	;
	sbci	var13,byte4(-128*zebra)	;

	mov	var20,var11		;und den 256sten Teil sichern
	mov	var21,var12		;
	mov	var22,var13		;

	ldi	var10,byte1(16777)	;lade Multiplikator
	ldi	var11,byte2(16777)	;K = 2^24/1000

	rcall	mul16x24u		;

	lsr	mod4			;dividiere durch 2 * Zebra
	ror	mod3			;
	ror	mod2			;

	lsr	mod4			;
	ror	mod3			;
	ror	mod2			;

	lsr	mod4			;
	ror	mod3			;
	ror	mod2			;
.if (zebra==8)
	lsr	mod4			;
	ror	mod3			;
	ror	mod2			;
.endif
	sts	wickelradius,mod2	;sichere den 2^16sten Teil
	sts	wickelradius+1,mod3	;
	ret

;*********************************************************************************************************
;**********	einen Punkt (entspricht dem "Kopfintervall", z.Zt. 8 Sekunden)			**********
;**********	auf die Betriebsstunden draufzhlen						**********
;**********	benutzte Register: var1[3:0], Stunden[2:0], Stunden_r[2:0], flags3		**********
;*********************************************************************************************************
addiere_kopfzeit:
	lds	var10,stunden		;hole Betriebsstunden
	lds	var11,stunden+1		;
	lds	var12,stunden+2		;

	subi	var10,byte1(-1)		;sonst 1 Tick = "Kopfstundenintervall" Sekunden draufgeben
	sbci	var11,byte2(-1)		;
	sbci	var12,byte3(-1)		;

	sts	stunden,var10		;wieder weglegen
	sts	stunden+1,var11		;
	sts	stunden+2,var12		;

	lds	var10,stunden_r		;hole rcksetzbare Betriebsstunden
	lds	var11,stunden_r+1	;
	lds	var12,stunden_r+2	;

	cpi	var10,byte1(max_stunden_r*3600/kopfintervall)	;bei Zhlerstand
	ldi	var13,byte2(max_stunden_r*3600/kopfintervall)	;max_stunden_r = 1000h
	cpc	var11,var13					;
	ldi	var13,byte3(max_stunden_r*3600/kopfintervall)	;
	cpc	var12,var13					;
	brlo	kopfzeit_gueltig				;

	clr	var10			;Stundenzhler r rcksetzen
	clr	var11			;
	clr	var12			;
kopfzeit_gueltig:
	subi	var10,byte1(-1)		;1 Tick = "Kopfstundenintervall" Sekunden draufgeben
	sbci	var11,byte2(-1)		;
	sbci	var12,byte3(-1)		;

	sts	stunden_r,var10		;wieder weglegen
	sts	stunden_r+1,var11	;
	sts	stunden_r+2,var12	;
ende_addiere_kopfzeit:
	ret

;*********************************************************************************************************
;**********	Den Inhalt des Betriebsstundenzhlers in Stunden umrechnen			**********
;**********	und fr die Darstellung im Display bereithalten					**********
;**********	Kopfstunden = Stundenzhler*kopfintervall/3600					**********
;**********	umgeformt zu: Stundenzhler*kopfintervall*4660,4/2^24				**********
;**********	benutzte Register: var1[2:0], Stunden[2:0], Stunden_r[2:0], var2[2:0], mod[4:0]	**********
;**********	stunden_anz[1:0], stunden_r_anz[1:0]						**********
;*********************************************************************************************************
rechne_stunden:
	lds	var20,stunden		;lade Dividend "Betriebsstundenzhler H"
	lds	var21,stunden+1		;
	lds	var22,stunden+2		;
	sbrs	flags2,stunden_volle	;
	rjmp	stunden_1		;
;**********	volle Stunden
	ldi	var10,byte1(kopfintervall*46604/10)	;lade Divisor K = 2^24/3600
	ldi	var11,byte2(kopfintervall*46604/10)	;zur Anzeige von vollen Stunden
	rjmp	stunden_2				;
stunden_1:
;**********	Stunden / 10
	ldi	var10,byte1(kopfintervall*466)		;lade Divisor K = 2^24/36000
	ldi	var11,byte2(kopfintervall*466)		;zur Anzeige von Stunden/10
stunden_2:
	rcall	mul16x24u		;
	sts	stunden_anz,mod3	;
	sts	stunden_anz+1,mod4	;
;rechne_stunden_r:
	lds	var20,stunden_r		;lade Dividend "rcksetzbarer Betriebsstundenzhler h"
	lds	var21,stunden_r+1	;
	lds	var22,stunden_r+2	;
	sbrc	flags2,stunden_zehntel	;
	rjmp	stunden_3		;
;**********	volle Stunden r		******************************************************************
	ldi	var10,byte1(kopfintervall*46604/10)	;lade Divisor K = 2^24/3600
	ldi	var11,byte2(kopfintervall*46604/10)	;zur Anzeige von vollen Stunden
	rcall	mul16x24u				;
	rjmp	stunden_4				;
stunden_3:
;**********	Stunden r x 10	= Zhlerstand * Kopfintervall /360	**********************************
	ldi	var10,byte1(kopfintervall*58255/10)	;lade Divisor K = 2^21/360
	ldi	var11,byte2(kopfintervall*58255/10)	;zur Anzeige von Stunden*10
	rcall	mul16x24u				;	
	lsl	mod2			;jetzt Ergebnis durch 2^21 teilen
	rol	mod3			;
	rol	mod4			;
	lsl	mod2			;
	rol	mod3			;indem ich zuerst mit 2^3 multipliziere
	rol	mod4			;
	lsl	mod2			;
	rol	mod3			;
	rol	mod4			;und unten durch 2^24 teile
stunden_4:
	sts	stunden_r_anz,mod3	;3 LowBytes verwerfen
	sts	stunden_r_anz+1,mod4	;
	ret

;*********************************************************************************************************
;**********	Den Gedamtbetriebsstundenzhler "H" auf 0 setzen				**********
;**********	benutzte Register: Stunden[2:0]							**********
;*********************************************************************************************************
loesche_stunden:
	sts	stunden,null		;
	sts	stunden+1,null		;
	sts	stunden+2,null		;
	ret

;*********************************************************************************************************
;**********	Den Betriebsstundenzhler "h" auf 0 setzen					**********
;**********	benutzte Register: Stunden_r[2:0]						**********
;*********************************************************************************************************
loesche_stunden_r:
	sts	stunden_r,null		;
	sts	stunden_r+1,null	;
	sts	stunden_r+2,null	;
	ret

;*********************************************************************************************************
;**********	Tastenkommando "kurz" schaltet rotierend die Anzeigemodi			**********
;**********	im Menmodus wird der Status der aktiven Optiongewechselt			**********
;**********	benutzte Register: var1[3:0], var2[2:0], blinker, zeiger_zeichen, Stunden[2:0]	**********
;**********	stunden_r[2:0], stunden_anz[1:0], stunden_r_anz[1:0], mod[4:0], fehleranzeige	**********
;*********************************************************************************************************
kommando_kurz:
;*********************************************************************************************************
;**********	bei anliegenden Fehlermeldungen das nchste gesetzte Fehlerbit finden und die	**********
;**********	dazugehrende Fehlernummer nach "Fehleranzeige" schreiben			**********
;*********************************************************************************************************
	tst	flags4			;bei anliegender Fehlermeldung
	breq	teste_auf_menue		;
	mov	var10,flags4		;Fehlerspeicher sichern
	ldi	var11,1			;
	lds	var12,fehleranzeige	;letzte angezeigte Fehlernummer laden
naechstes_fehlerbit:
	cpi	var12,8			;bei Fehlernummer 8
	breq	init_fehlersuche	;
schleife_fehlerbit:
	lsr	var10			;ein Bit nach rechts schieben
	inc	var11			;zugehrige Fehlernummer mitfhren
	dec	var12			;
	brne	schleife_fehlerbit	;
	rjmp	teste_lsb		;
;*********************************************************************************************************
;**********	nun 7 Bits in Richtung hherer Fehlernummern (nach Bit_7 Rcksetzen auf Bit_0)	**********
;**********	auf Fehlerstatus testen. Beim 8ten Bit aussteigen				**********
;*********************************************************************************************************
init_fehlersuche:
	mov	var10,flags4		;
	ldi	var11,1			;
teste_lsb:
	ldi	var12,8			;Schleifenzhler initialisieren
schleife_teste_lsb:
	dec	var12			;nach 8 abgesuchten Bits
	breq	ende_fehlerkommando	;fertig
	sbrc	var10,0			;lsb auf Fehlerstatus testen
	rjmp	neuer_fehler		;
	lsr	var10			;ein Bit weiterschieben
	inc	var11			;zugehrige Fehlernummer mitfhren
	cpi	var11,9			;
	brlo	schleife_teste_lsb	;
	ldi	var11,1			;Fehlersuche initialisieren
	mov	var10,flags4		;
	rjmp	schleife_teste_lsb	;
neuer_fehler:
	sts	fehleranzeige,var11	;Fehlernummer sichern
	nop
	nop
ende_fehlerkommando:
	rjmp	ende_kommando_kurz	;bei Fehlermeldung kein Kurzkommando
;*********************************************************************************************************
;**********	Menauswahl bedienen								**********
;*********************************************************************************************************
teste_auf_menue:
	mov	var10,flags3		;sichere Register
	andi	var10,alle_menuebits	;Menbits maskieren
	breq	ende_tastermenue	;
	cpi	var10,9			;Menpunkt 9, 10 und 11 bentigen Sonderbehandlung
	breq	menue_9			;
	cpi	var10,10		;
	breq	menue_10		;
	cpi	var10,11		;
	breq	menue_11		;
	rjmp	menue_1_bis_8		;
menue_9:
	lds	var10,hell_index	;
	inc	var10			;Helligkeitsindex erhhen
	cpi	var10,100+1		;
	brlo	helligkeit_gueltig	;
	ldi	var10,min_helligkeit	;bei ber 100 rcksetzen
helligkeit_gueltig:
	sts	hell_index,var10	;
	rcall	init_helligkeit		;
	rjmp	ende_kommando_kurz	;
menue_10:
	lds	var10,karussell		;
	inc	var10			;Helligkeitsindex erhhen
	cpi	var10,max_karussell	;
	brlo	karussell_gueltig	;
	ldi	var10,min_karussell	;rcksetzen
karussell_gueltig:
	sts	karussell,var10		;
	rjmp	ende_kommando_kurz	;
menue_11:
	lds	var10,stunden		;lade Stunden "H"
	lds	var11,stunden+1		;
	lds	var12,stunden+2		;
	subi	var10,byte1(-10*3600/kopfintervall)	;10 Stunden mehr
	sbci	var11,byte2(-10*3600/kopfintervall)
	sbci	var12,byte3(-10*3600/kopfintervall)
	sts	stunden,var10		;und wieder weglegen
	sts	stunden+1,var11		;
	sts	stunden+2,var12		;
	rcall	rechne_stunden		;zum Auffrischen der Anzeige
	rjmp	ende_kommando_kurz	;
menue_1_bis_8:
	ldi	var11,(1<<0)		;Bitmaske zum Toggeln MSB laden
schift_menue:
	cpi	var10,1			;die zum Menpunkt passende Bitmaske zum Toggeln erzeugen
	breq	toggele_option		;
	dec	var10			;
	lsl	var11			;
	rjmp	schift_menue		;
toggele_option:	
	eor	flags2,var11		;toggeln
	rjmp	ende_kommando_kurz	;
ende_tastermenue:
	sbis	pinb,e_geber_c		;wenn das Kassettenfach offen ist
	rjmp	ende_kommando_kurz	;keine weitere Aktion
;*********************************************************************************************************
;**********	Anzeigekarussell weiterschalten							**********
;*********************************************************************************************************
	sts	kennung,null		;Anzeige Kennbuchstaben anfordern
	mov	var10,index_modus	;sichere Modusflags
	andi	var10,alle_modusbits	;Modusbits maskieren
	sbrs	flags2,volle_modi	;bei eingeschrnktem Modusumfang
	rjmp	kleiner_modusbereich	;hier lang
;groer_modusbereich:
	cpi	var10,max_karussell-1	;nach dem letzten Modus kommt
	brlo	naechster_modus		;
	rjmp	setze_modus_0		;wieder erster
kleiner_modusbereich:
	lds	var11,karussell		;
	cp	var10,var11		;nach dem letzten Modus im kleinen Anzeigekarussell kommt
	brlo	naechster_modus		;
setze_modus_0:
	ldi	var10,~(alle_modusbits)	;wieder der Erste
	and	index_modus,var10	;
	rjmp	ende_kommando_kurz	;
naechster_modus:
	ldi	var11,(1<<modusbit_0)	;
	add	index_modus,var11	;sonst nchster Anzeigemodus bitte
	add	var10,var11		;
	cpi	var10,pos_l-1		;im Textmodus
	brne	ende_kommando_kurz	;
	ldi	var10,scrollintervall	;
	sts	kennung,var10		;keine Pause fr Kennbuchstaben
	sts	zeiger_zeichen,null	;Zeichenkette fngt beim Aufruf immer vorne an
ende_kommando_kurz:
	ret

;*********************************************************************************************************
;**********	Tastenkommando "lang" je nach Betrioebsart ausfhren				**********
;**********	Fehlermeldungen lschen oder Optionsmodus weiterschalten oder			**********
;**********	Umdrehungszhler nullen oder die rcksetzbaren Betriebsstunden nullen		**********
;**********	benutzte Register: Umdrehung[1:0], Feld, var1[2:0], Stunden[2:0],		**********
;**********	Stunden_r[2:0], var2[2:0], mod[4:0], stunden_anz[1:0], stunden_r_anz[1:0]	**********
;**********	flags3, blinker_maske								**********
;*********************************************************************************************************
kommando_lang:
;*********************************************************************************************************
;**********	Fehlercodes lschen								**********
;*********************************************************************************************************
	tst	flags4			;bei anliegendem Fehler
	breq	keine_fehlercodes	;
	clr	flags4			;alle Fehlercodes lschen
	sts	fehleranzeige,null	;Setzen der Fehlernummer freigeben
	sts	kennung,null		;Anzeige Kennbuchstaben anfordern
	sts	blinkermaske,null	;kein Blinken mehr
	rjmp	ende_kommando_lang	;
keine_fehlercodes:
;*********************************************************************************************************
;**********	Mennummer weiterschalten							**********
;*********************************************************************************************************
	mov	var10,flags3		;sichere Register
	andi	var10,alle_menuebits	;maskiere Men
	breq	ende_menue		;
	cpi	var10,max_menue		;nach dem letzten Menpunkt kommt
	brsh	verlasse_menue		;Normalbetrieb (alle Menbits = 0)
	inc	flags3			;sonst nchster Menpunkt bitte
	sts	blinker,null		;Digitblinken auf Tastendruck synchronisieren
;**********	Menpunkt 8 berspringen
	mov	var10,flags3		;sichere Men
	andi	var10,alle_menuebits	;maskiere Men
	cpi	var10,8			;ungenutzter Menpunkt 8 wird 
	brne	ende_kommando_lang	;
	subi	flags3,-(1<<menuebit_0)	;bersprungen
	rjmp	ende_kommando_lang	;
verlasse_menue:
	mov	var10,flags2		;sichere alle Optionen
	ldi	var11,adr_eeprom+11	;ins EEPROM
	rcall	eewrite3		;
	cbr	flags3,alle_menuebits	;
	rcall	rechne_stunden		;ntig fr Aktualisierung der Stundenanzeige
	sts	blinkermaske,null	;keine blinkenden Digits mehr
	sts	kennung,null		;Anzeige Kennbuchstaben anfordern
	rjmp	ende_kommando_lang	;
ende_menue:
	sbis	pinb,e_geber_c		;wenn das Kassettenfach offen ist
	rjmp	ende_kommando_lang	;keine weitere Aktion
;*********************************************************************************************************
;**********	Umdrehungen und Stunden "h" rcksetzen						**********
;*********************************************************************************************************
	mov	var10,index_modus	;sichere Flags
	andi	var10,alle_modusbits	;maskiere Anzeigemodus
	cpi	var10,pos_u-1		;im Modus "Umdrehungen U"
	breq	nulle_umdrehungen	;Zhler lschen
	cpi	var10,pos_h-1		;im Modus rcksetzbare Betriebsstunden
	brne	ende_kommando_lang	;
;nulle_stunden_r:
	rcall	loesche_stunden_r	;Stunden lschen
	rcall	rechne_stunden		;und einmal fr die Anzeige rechnen
	rjmp	ende_kommando_lang	;
nulle_umdrehungen:
	sts	umdrehungszahl,null	;Umdrehungszhler nullen
	sts	umdrehungszahl+1,null	;
ende_kommando_lang:
	ret

;*********************************************************************************************************
;**********	Ringspeicher S mit sinkenden Werten fllen, dass sich aus dem Speicherinhalt	**********
;**********	die aktuelle Dicke ergbe und dass durch das Einlaufen von frischen Werten	**********
;**********	keine groe Schwankung entsteht.						**********
;**********	Pro Umdrehung verlangsamt sich die Tellergeschwindigkeit um:			**********
;**********	Delta T-Segm = Banddicke * 2 * Pi * CLK/(Vo * zebra * Vorteiler1)		**********
;**********	pro Segment um:									**********
;**********	Delta T-Segm = Dickenwert * 2 * Pi * CLK/(Vo * zebra^2 * Vorteiler1 * 100000)	**********
;**********	Umgeformt und normiert zu:							**********
;**********	Delta T-Segm = dickenwert * K/zebra^2    K=2*Pi*CLK/(Vo*Vorteiler1*100000)	**********
;**********	benutzte Register: var1[3:0], var2[3:0], mod[3:0], Z				**********
;*********************************************************************************************************
init_speicher_s:
;*********************************************************************************************************
;**********	Werte der ersten gltigen Umdrehung aus dem Speicher holen und einen		**********
;**********	Startwert zu Initialisierung bilden.						**********
;*********************************************************************************************************
	clr	var20			;Ergebnisregister lschen
	clr	var21			;
	clr	var22			;
	ldi	zl,byte1(speicher_s+feldersperre)	;
	ldi	zh,byte2(speicher_s+feldersperre)	;Zeiger einstellen
summiere_startwert:
	ld	var10,z+		;Wert laden
	ld	var11,z+		;
	add	var20,var10		;summieren
	adc	var21,var11		;
	adc	var22,null		;

	cpi	zl,byte1(speicher_s+feldersperre+2*zebra);Werte fr eine ganze Umdrehung eingelesen?
	ldi	var12,byte2(speicher_s+feldersperre+2*zebra)
	cpc	zh,var12		;

	brlo	summiere_startwert	;
	subi	var20,byte1(-zebra/2)	;runden
	sbci	var21,byte2(-zebra/2)	;
	sbci	var22,byte3(-zebra/2)	;

	lsr	var22			;durch zebra dividieren
	ror	var21			;
	ror	var20			;
	lsr	var22			;
	ror	var21			;
	ror	var20			;
.if (zebra==8)
	lsr	var22			;
	ror	var21			;
	ror	var20			;
.endif
	sts	t_segm_init,var20	;ergibt die mittlere Segmentlaufzeit der letzten Umdrehung
	sts	t_segm_init+1,var21	;

	lds	var10,dicke+2		;hole Dickenwert zur Initialisierung
	lds	var11,dicke+3		;nur Ganzzahlanteil

;*******  nicht produktiv  **************
;	lds	var10,dicke_init	;hole Dickenwert zur Initialisierung
;	lds	var11,dicke_init+1	;
;*******  E N D E  **********************

	ldi	var20,byte1(65883973167/(bandgeschw*zebra*zebra))	;lade Multiplikator (21672)
	ldi	var21,byte2(65883973167/(bandgeschw*zebra*zebra))	;K = 2*Pi*CLK*2^24/(Vorteiler1*100)

	rcall	mul16u			;rechne: "dicke * 21672" und dividiere durch 2^24

	mov	var20,mod0		;die unteren 3 Byte sichern
	mov	var21,mod1		;das sind die Nachkommastellen
	mov	var22,mod2		;
	clr	var23			;
	mov	var12,mod2		;Wert fr Offsetberechnung nochmal sichern
	mov	var13,mod3		;

	lds	var10,t_segm_init	;mittlere Segmentlaufzeit der letzten Umdrehung holen
	lds	var11,t_segm_init+1	;

;*********************************************************************************************************
;**********	Die mittlere Segmentlaufzeit hinkt eine halbe Umdrehung hinter der aktuellen	**********
;**********	her und bekommt daher einen positiven Offset zur Kompensation:			**********
;**********	Offset = zebra/2*mod[3:0]							**********
;**********	Maximaler Fehler dieser Anwendung ist 0,25; unabhngig von der Speichergre.	**********
;*********************************************************************************************************
	lsl	var12			;Offset multiplizieren mit zebra/2
	rol	var13			;
.if (zebra==8)
	lsl	var12			;
	rol	var13			;
.endif
	add	var10,var13		;Offset draufgeben, nur Ganzzahlanteil
	adc	var11,null		;

	ldi	zl,byte1(speicher_s+2*k_1)	;k_1=zebra*(mittelwerttiefe+delta_s)
	ldi	zh,byte2(speicher_s+2*k_1)	;Zeiger auf Ende "Speicher S" stellen
schleife_init_s:
	st	-z,var11		;eine Speicherzelle tiefer anwhlen (pre-decrement)
	st	-z,var10		;und zuerst High-Byte ablegen

	sub	var10,mod3		;nchsten Wert T-Segm rechnen
	sbc	var11,null		;mod3 ist der Ganzzahlanteil des Offsets

	sub	var10,var23		;im Schleifendurchlauf aufsummierten Nachkommaanteil
	sbc	var11,null		;subtrahieren
	clr	var23			;

	add	var20,mod0		;den nicht verwendeten Nachkommarest
	adc	var21,mod1		;bei jedem Umlauf aufsummieren
	adc	var22,mod2		;
	adc	var23,null		;ergibt hier dann bald einen ganzzahligen bertrag

	cpi	zl,byte1(speicher_s)	;
	ldi	var12,byte2(speicher_s)	;
	cpc	zh,var12		;
	brne	schleife_init_s		;ganzer Speicher voll?

	sts	zeiger_s,null		;Zeiger auf Anfang
	sts	zeiger_s+1,null		;
	ret				;
	
;*********************************************************************************************************
;**********	Variablen fr die Helligkeitssteuerung der Anzeige laden			**********
;**********	benutzte Register: var1[2:0], var2[1:0], mod[3:0], r0, r1, hell_min, hell_max	**********
;**********	dimmer, kennung									**********
;*********************************************************************************************************
init_helligkeit:
	lds	var10,hell_index	;hole Helligkeitsindex in %
	clr	var11			;
	ldi	var20,byte1(653)	;absolute Helligkeit =
	ldi	var21,byte2(653)	;	
	rcall	mul16u			;"Helligkeitsindex*653/256"
	sts	hell_absolut,mod1	;(2 bis 255)
	ldi	var12,24		;Minimumhelligkeit und Schrittweite Dimmersteuerung =
	mul	var10,var12		;
	mov	var12,r1		;"Helligkeitsindex*24/256+1"
	subi	var12,-1		;
	sts	dimmer_min,var12	;(1 bis 10)
	ldi	var20,byte1(630)	;Maximumhelligkeit Dimmersteuerung =
	ldi	var21,byte2(630)	;	
	rcall	mul16u			;"Helligkeitsindex*630/256"
	sts	dimmer_max,mod1		;(2 bis 246)
	sts	dimmer,null		;
	sts	kennung,null		;Anzeige Kennbuchstaben anfordern
	ret

;*********************************************************************************************************
;**********	Defaultwert des Kernradius fr die Berechnungen laden				**********
;**********	benutzte Register: var1[2:0], Kernradius[2:0]					**********
;*********************************************************************************************************
init_Kernradius:
	ldi	var10,byte1(def_kern*100)	;Default-Radius des leeren Wickeltellers
	ldi	var11,byte2(def_kern*100)	;bereithalten
	ldi	var12,byte3(def_kern*100)	;
	sts	Kernradius,var10		;
	sts	Kernradius+1,var11		;
	sts	Kernradius+2,var12		;
	ret

;*********************************************************************************************************
;**********	SRAM lschen									**********
;**********	benutzte Register: var10, Z							**********
;*********************************************************************************************************
loesche_sram:
	ldi	zl,byte1(sram_start)	;Zeiger auf Beginn SRAM-Bereich einstellen
	ldi	zh,byte2(sram_start)	
clr_ram:				;
	st	z+,null			;und lschen
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;der Loop-Unroll macht das Ganze etwas schneller
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	st	z+,null			;
	cpi	zl,byte1(ramend-16)	;den Stackpointerbereich grozgig aussparen
	ldi	var10,byte2(ramend-16)	;hilft Probleme zu vermeiden :-)
	cpc	zh,var10		;
	brlo	clr_ram			;
	ret

;*********************************************************************************************************
;**********	sichere Zhlerstnde ins EEPROM:						**********
;**********	Anzeigemodus, Banddicke, Bandlagen, Betriebsstunden				**********
;**********	benutzte Register: var1[1:0], EEARL, EEARH, EECR, EEDR				**********
;*********************************************************************************************************
rette_werte:
	cli				;keine ISR mehr ausfhren
.if (gem_anode!=1)
	ldi	var10,(1<<a_ir_led)	;schalte
.else
	ldi	var10,~(1<<a_ir_led)	;schalte
.endif
	out	portc,var10		;alle Digits und Lichtschranken aus
.if (gem_anode!=1)
	ldi	var10,~alle_segmente	;
.else
	ldi	var10,alle_segmente	;
.endif
	out	portd,var10		;alle Segmente aus
	sbi	portb,a_stop		;Nullstopp-Ausgang setzen, Debug-LED aus

	ldi	var10,(1<<WDCE)|(1<<WDE);Watchdog-Timer zum Schalten vorbereiten
	out	WDTCR,var10		;
	ldi	var10,(1<<WDCE)		;und abschalten
	out	WDTCR,var10		;

	sbis	pinb,e_taster		;wenn Taster beim Ausschalten gedrckt ist
	rcall	loesche_stunden		;Kopfstundenzhler lschen

	ldi	var11,adr_eeprom+1	;setze EEPROM-Adresse
	lds	var10,stunden		;sichere Betriebsstunden
	rcall	eewrite3		;
	ldi	var11,adr_eeprom+2	;
	lds	var10,stunden+1		;
	rcall	eewrite3		;
	ldi	var11,adr_eeprom+3	;
	lds	var10,stunden+2		;
	rcall	eewrite3		;

	ldi	var11,adr_eeprom+4	;
	lds	var10,stunden_r		;sichere rcksetzbare Betriebsstunden
	rcall	eewrite3		;
	ldi	var11,adr_eeprom+5	;
	lds	var10,stunden_r+1	;
	rcall	eewrite3		;
	ldi	var11,adr_eeprom+6	;
	lds	var10,stunden_r+2	;
	rcall	eewrite3		;

	ldi	var11,adr_eeprom+7	;
	lds	var10,umdrehungszahl	;sichere Umdrehungen
	rcall	eewrite3		;
	ldi	var11,adr_eeprom+8	;
	lds	var10,umdrehungszahl+1	;
	rcall	eewrite3		;

	ldi	var11,adr_eeprom+9	;
	lds	var10,dicke+2		;sichere Dickenwert
	rcall	eewrite3		;
	ldi	var11,adr_eeprom+10	;
	lds	var10,dicke+3		;
	rcall	eewrite3		;

	ldi	var11,adr_eeprom+11	;sichere Optionen
	mov	var10,flags2		;
	rcall	eewrite3		;

	ldi	var11,adr_eeprom+12	;
	lds	var10,hell_index	;sichere Anzeigehelligkeit
	rcall	eewrite3		;

	ldi	var11,adr_eeprom+13	;
	lds	var10,karussell		;sichere Gre kleines Anzeigekarussell
	rcall	eewrite3		;

	ldi	var11,adr_eeprom+14	;
	mov	var10,index_modus	;sichere letzten Anzeigemodus
	rcall	eewrite3		;

	nop				;hier warten

;*******  T E S T  **********************
	rjmp	fehler_abschaltung	;
;*******  E N D E  **********************

	rjmp	PC-1			;bis der Strom ganz weg ist

;*********************************************************************************************************
;**********	Daten aus dem EEPROM in die Anwednung laden					**********
;**********	dazu ist es in 3 gleiche Bereiche aufgeteilt, in denen die Daten		**********
;**********	von jedem Prozess redundant als Tripel abgelegt werden				**********
;**********	benutzte Register: var1[1:0], EEARL, EEARH, EECR, EEDR, stunden[2:0], flags2	**********
;**********			   stunden_r[2:0], umdrehungszahl[1:0], dicke[3:2], karussell	**********
;**********			   hell_index, index_modus					**********
;*********************************************************************************************************
lade_eeprom:
	ldi	var11,adr_eeprom+1	;
	rcall	eeread			;
	sts	stunden,var10		;
	ldi	var11,adr_eeprom+2	;
	rcall	eeread			;
	sts	stunden+1,var10		;
	ldi	var11,adr_eeprom+3	;
	rcall	eeread			;
	sts	stunden+2,var10		;die Gesamtbetriebsstunden

	ldi	var11,adr_eeprom+4	;
	rcall	eeread			;
	sts	stunden_r,var10		;
	ldi	var11,adr_eeprom+5	;
	rcall	eeread			;
	sts	stunden_r+1,var10	;
	ldi	var11,adr_eeprom+6	;
	rcall	eeread			;
	sts	stunden_r+2,var10	;die rcksetzbaren Betriebsstunden

	ldi	var11,Adr_eeprom+7	;
	rcall	eeread			;
	sts	umdrehungszahl,var10	;
	ldi	var11,adr_eeprom+8	;
	rcall	eeread			;
	sts	umdrehungszahl+1,var10	;den letzten Zhlwerksstand

	ldi	var11,adr_eeprom+9	;
	rcall	eeread			;
	sts	dicke+2,var10		;
	ldi	var11,adr_eeprom+10	;
	rcall	eeread			;
	sts	dicke+3,var10		;den letzten Dickenwert

	ldi	var11,adr_eeprom+11	;
	rcall	eeread			;
	mov	flags2,var10		;die Optionen

	ldi	var11,adr_eeprom+12	;
	rcall	eeread			;
	sts	hell_index,var10	;die Anzeigehelligkeit in Prozent

	ldi	var11,adr_eeprom+13	;
	rcall	eeread			;
	sts	karussell,var10		;die Gre des kleinen Anzeigekarussells

	ldi	var11,adr_eeprom+14	;
	rcall	eeread			;
	mov	index_modus,var10	;den letzten Anzeigemodus
	ret				;

;*********************************************************************************************************
;**********	EEPROM auf korrupte Zellen hin absuchen und Reparaturen durchfhren		**********
;**********	dazu ist es in 3 gleiche Bereiche aufgeteilt, in denen die Daten		**********
;**********	von jedem Prozess redundant als Tripel abgelegt werden				**********
;**********	benutzte Register: var1[1:0], var2[3:0], flags3					**********
;*********************************************************************************************************
teste_eeprom:
	ser	var20			;mit dieser Adresse erreichen wir gleich erstmal die Null
neues_tripel:
	inc	var20			;nchste Adresse
	mov	var11,var20		;sichere Adresse
	cpi	var11,80		;schon bei der 81sten Zelle angekommen
	brsh	end_korr		;dann fertig und raus

	rcall	eeread			;
	mov	var21,var10		;hole Daten A
	subi	var11,-80		;setze Adresse fr B (80 Zellen hher)
	rcall	eeread			;
	mov	var22,var10		;hole Daten B
	subi	var11,-80		;setze Adresse fr C (noch 80 Zellen hher)
	rcall	eeread			;
	mov	var23,var10		;hole Daten C

	cpse	var21,var22		;A = B ?
	rjmp	BundC			;nein

	cp	var21,var23		;A = C ?
	breq	neues_tripel		;keine Korruption, nchstes Tripel holen

	mov	var12,var21		;C defekt, hole Daten A(=B)
	rcall	eewrite			;und repariere C
	sbr	flags4,(1<<fehler_4)	;Fehlercode 4: "EEPROM Fehler", C repariert
	rcall	setze_fehlernummer	;
	rjmp	neues_tripel		;Daten repariert, nchstes Tripel holen
BundC:
	cpse	var22,var23		;B = C ?
	rjmp	AundC			;nein
	mov	var12,var22		;A defekt, hole Daten B(=C)
	subi	var11,160		;lade Adresse A
	rcall	eewrite			;und repariere A
	sbr	flags4,(1<<fehler_2)	;Fehlercode 2: "EEPROM Fehler", A repariert
	rcall	setze_fehlernummer	;
	rjmp	neues_tripel		;Daten repariert, nchstes Tripel holen
AundC:	
	cpse	var21,var23		;A = C ?	
	rjmp	ABCdefekt		;nein
	mov	var12,var23		;B defekt, hole Daten C(=A)
	subi	var11,80		;lade Adresse B
	rcall	eewrite			;und repariere B
	sbr	flags4,(1<<fehler_3)	;Fehlercode 3: "EEPROM Fehler", B repariert
	rcall	setze_fehlernummer	;
	rjmp	neues_tripel		;Daten repariert, nchste Adresse holen
ABCdefekt:				;zwei Werte von A, B und C als defekt erkannt
	mov	var12,var21		;alle Daten unterschiedlich, hole Daten A
	rcall	eewrite			;und repariere damit C
	subi	var11,80		;und auf Adresse B
	rcall	eewrite			;auch B
	sbr	flags4,(1<<fehler_1)	;Fehlercode 1: "EEPROM Daten nicht sicher rekonstruiert"
	rcall	setze_fehlernummer	;
	rjmp	neues_tripel		;nchstes Tripel holen
end_korr:
	ret

;*********************************************************************************************************
;**********	EEPROM initialisieren								**********
;**********	ein fabrikfrisches EEPROM wird gelscht und mit Default-Werten beschrieben	**********
;**********	benutzte Register: var1[1:0], EEARL, EEARH, EECR, EEDR				**********
;*********************************************************************************************************
init_eeprom:
	clr	var10			;lsche
	clr	var11			;die untersten 256 Byte des EEPROMs
initee:
	rcall	eewrite			;bitte
	inc	var11			;nchste Adresse
	tst	var11			;schon am Ende des genutzten Bereiches (256 Byte) angekommen ?
	brne	initee			;
					;dann beflle mit den Defaultwerten
	ldi	var10,byte1(def_stunden*3600/Kopfintervall)	;Kopfstunden
	ldi	var11,adr_eeprom+1	;
	rcall	eewrite3		;
	ldi	var10,byte2(def_stunden*3600/Kopfintervall)
	ldi	var11,adr_eeprom+2	;
	rcall	eewrite3		;
	ldi	var10,byte3(def_stunden*3600/Kopfintervall)
	ldi	var11,adr_eeprom+3	;
	rcall	eewrite3		;

	ldi	var10,byte1(def_stunden_r*3600/Kopfintervall)	;Kopfstunden, rcksetzbar
	ldi	var11,adr_eeprom+4	;
	rcall	eewrite3		;
	ldi	var10,byte2(def_stunden_r*3600/Kopfintervall)
	ldi	var11,adr_eeprom+5	;
	rcall	eewrite3		;
	ldi	var10,byte3(def_stunden_r*3600/Kopfintervall)
	ldi	var11,adr_eeprom+6	;
	rcall	eewrite3		;

	ldi	var10,byte1(def_dicke/10);default Dickenwert
	ldi	var11,adr_eeprom+9	;
	rcall	eewrite3		;
	ldi	var10,byte2(def_dicke/10);
	ldi	var11,adr_eeprom+10	;
	rcall	eewrite3		;

	ldi	var10,def_option	;default Optionsmodus
	ldi	var11,adr_eeprom+11	;
	rcall	eewrite3		;

	ldi	var10,def_helligkeit	;default Anzeigehelligkeit
	ldi	var11,adr_eeprom+12	;
	rcall	eewrite3		;

	ldi	var10,def_karussell	;default Gre kleines Anzeigekarussell
	ldi	var11,adr_eeprom+13	;
	rcall	eewrite3		;

	clr	var10			;Anzeigemodus "T"
	ldi	var11,adr_eeprom+14	;
	rcall	eewrite3		;

	ldi	var11,adr_eeprom	;vermerke die Initialisierung nun in Zelle 1
	ldi	var10,0xaa		;mit dem Bitmuster "AA"
	rcall	eewrite3		;
	ret

;*********************************************************************************************************
;**********	Daten aus var10 ins EEPROM auf Adresse in var11 schreiben			**********
;**********	benutzte Register: var1[1:0], EEARL, EEARH, EECR, EEDR				**********
;*********************************************************************************************************
eewrite:
	sbic	EECR,EEWE		;ist das EEPROM empfangsbereit ?
	rjmp	eewrite			;nein, warte noch
	out	EEARH,null		;die oberen 256 Byte nicht anfassen
	out	EEARL,var11		;EEPROM-Adresse setzen,
	out	EEDR,var10		;Daten ins Schreibregister holen
	sbi	EECR,EEMWE		;MasterWriteEnable setzen
	sbi	EECR,EEWE		;und strobe EEPROM
	ret

;*********************************************************************************************************
;**********	Daten in var10 als Tripel mit 80 Zellen Abstand ins EEPROM schreiben		**********
;**********	anfangend mit Adresse aus var11							**********
;**********	benutzte Register: var1[1:0], EEARL, EEARH, EECR, EEDR				**********
;*********************************************************************************************************
eewrite3:
	rcall	eewrite			;schreibe auf Adresse A
	subi	var11,-80		;
	rcall	eewrite			;und B (A + 80)
	subi	var11,-80		;
	rcall	eewrite			;und C (A + 160)
	subi	var11,160		;Einstiegsadresse var11 wieder herstellen
	ret

;*********************************************************************************************************
;**********	Daten aus dem EEPROM von Adresse var11 holen					**********
;**********	und in var10 zur Weiterverarbeitung bereithalten				**********
;**********	benutzte Register: var1[1:0], EEARL, EEARH, EECR, EEDR				**********
;*********************************************************************************************************
eeread:	
	sbic	EECR,EEWE		;wenn das EEPROM mit Schreiben beschftigt,
	rjmp	eeread			;warten
	out	EEARH,null		;die oberen 256 Byte nicht anfassen
	out	EEARL,var11		;sende Adresse
	sbi	EECR,EERE		;strobe EEPROM
	in	var10,EEDR		;dann stehen die Daten in var10 bereit
	ret
